<?php
namespace FreePBX\modules;

include_once("voximal-def.inc");
/*
define("WEBDIR",  			"/var/www/html/vxml/");
define("AUDIODIR",			"/var/spool/asterisk/");
define("VXML_VALIDATOR",	"/usr/sbin/voximalv");
*/


/*define("FPBX_LOG_FATAL",    "FATAL");
define("FPBX_LOG_CRITICAL", "CRITICAL");
define("FPBX_LOG_SECURITY", "SECURITY");
define("FPBX_LOG_SIGNATURE_UNSIGNED", "SIGNATURE_UNSIGNED");
define("FPBX_LOG_UPDATE",   "UPDATE");
define("FPBX_LOG_ERROR",    "ERROR");
define("FPBX_LOG_WARNING",  "WARNING");
define("FPBX_LOG_NOTICE",   "NOTICE");
define("FPBX_LOG_INFO",     "INFO");
define("FPBX_LOG_PHP",      "PHP");
*/
function debugjyg($line) {
	//echo "$line<br>";
	//freepbx_log(FPBX_LOG_CRITICAL,$line);
}
function VoxiFpbxLog($line) {
	freepbx_log(FPBX_LOG_NOTICE,"[Voximal] - " . $line);
}


global $vFilemanager_pathlist;

		
/*
 * Class stub for BMO Module class
 * In _Construct you may remove the database line if you don't use it
 * In getActionbar change "modulename" to the display value for the page
 * In getActionbar change extdisplay to align with whatever variable you use to decide if the page is in edit mode.
 *
 */
class Voximal implements \BMO {
	
	
	public function __construct($freepbx = null) {
		if ($freepbx == null) {
			throw new Exception("Not given a FreePBX Object");
		}
		$this->FreePBX = $freepbx;
		$this->db = $freepbx->Database;
	}
	public function install() {}
	public function uninstall() {}
	public function backup() {}
	public function restore($backup) {}

	public function getDefaultAppPath() {return WEBDIR;}
	
	
	/**
	 * Callback for submit
	 */
	public function doConfigPageInit($page) {
		// Debug
		//if (isset($_REQUEST['action']))  debugjyg("ACTION=".$_REQUEST['action']");
		//if (isset($_REQUEST['display'])) debugjyg("display=".$_REQUEST['display']");
		//print_r($_REQUEST);echo "<br>";
		/*
		debugjyg("==== DBGJYG: doConfigPageInit:REQ: action=".$_REQUEST['action'] . " display=".$_REQUEST['display']);
		foreach($_REQUEST as $rk => $rv) {
			debugjyg("            $rk => '$rv'");
		}
		*/
		
		if (isset($_REQUEST['action'])) {
			if ($_REQUEST['action'] == 'save') {
				if (isset($_REQUEST['display']) ) {
					if ($_REQUEST['display'] == 'voximalsettings') {
						//debugjyg(" call doPostSaveSettings!!");
						$this->doPostSaveSettings();
					}
					/* Action for Filemanager */
					else if ($_REQUEST['display'] == 'voximalfilemanager') {
						$pathfilename = WEBDIR;
						if (isset($_REQUEST['filepath'])) {
							$pathfilename = $this->getBaseAllowedPath($_REQUEST['filepath']); //WEWEWE 85
						}
						if (isset($_REQUEST['folder'])) {
							if (isset($_REQUEST['root']) && ($_REQUEST['root'] != "root")) {
								$pathfilename .= "/" . $_REQUEST['root'];		
							}
							$pathfilename .= "/" . $_REQUEST['folder'];		
						}

						if (isset($_REQUEST['filename']) && isset($_REQUEST['code'])) {
							$pathfilename .= "/" . $_REQUEST['filename'];
							debugjyg("==== DBGJYG: doConfigPageInit: save file=$pathfilename");
							$this->saveEditedFile($pathfilename, $_REQUEST['code']);
						}

					}
					/* Action for Edit ACCOUNT */
					else if (($_REQUEST['display'] == 'voximalapp') && ($_REQUEST['view'] == 'editaccount')) {
						if (isset($_REQUEST['id']) && !empty($_REQUEST['id'])) {
								$modifiedvoximal = array(
										"name"		=> $_POST['name'],
										"number"		=> $_POST['number'],
										"url" 		=> $_POST['url'],
										"maxsessions"	=> $_POST['maxsessions'],
										"dialformat"	=> $_POST['dialformat'],
										"mark"		=> $_POST['mark'],
										"speech"	=> $_POST['speech'],
										"speechprovider" => $_POST['speechprovider'],
										"startdelay"=> $_POST["startdelay"] ,
										"vxmlparam" => $_POST["vxmlparam"] ,
										"maxtime"   => $_POST["maxtime"] ,
										"goto"		=> "app-blackhole,hangup,1", //$_POST[$_POST['goto0']."0"]
										"additionalparams"	=> $_POST['additionalparams'],
								);
								updateVoximal($_POST['prevname'], $modifiedvoximal);
								needreload();
								unset($_REQUEST['view']);
						}
						else {
							$voximal = array(
										"name" => $_POST['name'],
										"number" => $_POST['number'],
										"url" => $_POST['url'],
										"maxsessions" => $_POST['maxsessions'],
										"dialformat" => $_POST['dialformat'],
										"mark" => $_POST['mark'],
										"speech" => $_POST['speech'],
										"speechprovider" => $_POST['speechprovider'],
									    "startdelay" => $_POST["startdelay"] ,
										"vxmlparam"  => $_POST["vxmlparam"] ,
										"maxtime"    => $_POST["maxtime"] ,
										"goto" => "app-blackhole,hangup,1", //$_POST[$_POST['goto0']."0"]
										"additionalparams"	=> $_POST['additionalparams'],
								);
							$this->addAccount($voximal);
              						needreload();
							unset($_REQUEST['view']);
						}
					}
					else {
						// Unsupported display
						debugjyg("==== DBGJYG: doConfigPageInit: action=save unsupported display '".$_REQUEST['display']."'");
					}
				}
			}
			else if ($_REQUEST['action'] == 'delete') {
				if (isset($_REQUEST['id']) ) {
					//echo " Delete account id=".$_REQUEST['id']."<br>";
					$this->delAccountById($_REQUEST['id']);
					needreload();
					
				} else if (isset($_REQUEST['filename']) && ($_REQUEST['display'] == 'voximalfilemanager')) {
					//echo " Delete vxml file=".$_REQUEST['filename']."<br>";
					$pathfilename = WEBDIR;
					//if (isset($_REQUEST['filepath']) && ($_REQUEST['filepath'] == "audio")) {
					//	$pathfilename = AUDIODIR;
					//}
					if (isset($_REQUEST['filepath'])) {
						$pathfilename = $this->getBaseAllowedPath($_REQUEST['filepath']);
					}
					
					if (isset($_REQUEST['folder'])) {
						if (isset($_REQUEST['root']) && ($_REQUEST['root'] != "root")) {
							$pathfilename .= "/" . $_REQUEST['root'];		
						}
						$pathfilename .= "/" . $_REQUEST['folder'];		
					}

					$pathfilename .= "/" . $_REQUEST['filename'];
					debugjyg("==== DBGJYG: doConfigPageInit: remove file=".$pathfilename );
					$this->delVxmlFile($pathfilename);
				}
			}
			else if ($_REQUEST['action'] == 'adddir') {
				$pathname = WEBDIR;
				//if (isset($_REQUEST['filepath']) && ($_REQUEST['filepath'] == "audio")) {
				//	$pathname = AUDIODIR;
				//}
				if (isset($_REQUEST['filepath'])) {
					$pathname = $this->getBaseAllowedPath($_REQUEST['filepath']);
				}

				if (isset($_REQUEST['folder'])) {
					if (isset($_REQUEST['root']) && ($_REQUEST['root'] != "root")) {
						$pathname .= "/" . $_REQUEST['root'];		
					}
					$pathname .= "/" . $_REQUEST['folder'];		
				}

				$pathname .= "/" . $_REQUEST['newfoldername'];
				debugjyg("==== DBGJYG: doConfigPageInit: adddir=".$pathname );
				$this->addDirectory($pathname);
			}
			else if ($_REQUEST['action'] == 'addfile') {
				$pathname = WEBDIR;
				//if (isset($_REQUEST['filepath']) && ($_REQUEST['filepath'] == "audio")) {
				//	$pathname = AUDIODIR;
				//}
				if (isset($_REQUEST['filepath'])) {
					$pathname = $this->getBaseAllowedPath($_REQUEST['filepath']);
				}

				if (isset($_REQUEST['folder'])) {
					if (isset($_REQUEST['root']) && ($_REQUEST['root'] != "root")) {
						$pathname .= "/" . $_REQUEST['root'];		
					}
					$pathname .= "/" . $_REQUEST['folder'];		
				}

				$pathname .= "/" . $_REQUEST['newfilename'];
				debugjyg("==== DBGJYG: doConfigPageInit: addfile=".$pathname );
				$this->addFile($pathname);
			}
			else if ($_REQUEST['action'] == 'download') {
				// "/var/www/html/voxibot/configs" -> path for voxibot config files
				// "/var/www/html/voxibot/vxml/voicexml" -> path for voxibot application files
				$downloadPath = "";
				switch ($_REQUEST['filepath']) {
					case 'vxml':
						$downloadPath = "/var/www/html/vxml/";
					case '':
						$downloadPath = "/var/www/html/vxml/";
					break;
					case 'tpl':
						$downloadPath = "/var/www/html/admin/modules/voxistats/lib/api/tpl/";
					break;
					case 'unimrcp':
						$downloadPath = "/usr/local/unimrcp/conf/";
					break;
					case 'audio':
						$downloadPath = "/var/spool/asterisk/";
					break;
				}
				if ($_REQUEST['filename'])
					$downloadPath = $downloadPath . $_REQUEST['filename'];
				download_file($downloadPath, '', '', true);
			}
		}
	}
	
	public function doPostSaveSettings() {
		$settings = array (
				"recordsilence"		=> trim($_POST['recordsilence']),
				"threshold"			=> trim($_POST['threshold']),
				"wavdefaultcodec"	=> trim($_POST['wavdefaultcodec']),
				"debug"				=> trim($_POST['debug']),
				"monitor"			=> trim($_POST['monitor']),
				"priorityevents"	=> trim($_POST['priorityevents']),
				"cachetimeout"		=> trim($_POST['cachetimeout']),
				"dialformat"		=> trim($_POST['dialformat']),
				"blindapplication"  => trim($_POST['blindapplication']),
				//"logsapache"    => trim($_POST['logsapache']),
				//"logsvoximal"   => trim($_POST['logsvoximal']),
				//"logsvxml"      => trim($_POST['logsvxml'])
				"speechprovider"	=> trim($_POST['speechprovider']),
				"speechbeeps"		=> trim($_POST['speechbeeps']),
		);
		//print_r($settings);echo "<br>";
		//modifyVoximalConfiguration($settings);
		saveGeneralConf($settings);
		
		//ASR
		$asrsettings = array (
				"api" 		=> trim($_POST['asrapi']),
				"uri" 		=> trim($_POST['asruri']),
				"method" 	=> trim($_POST['asrmethod']),
				"format" 	=> trim($_POST['asrformat']),
				"id"  		=> trim($_POST['asrid']),
				"key" 		=> trim($_POST['asrkey']),
				"user"  	=> trim($_POST['asruser']),
				"password" 	=> trim($_POST['asrpassword']),
				"model" 	=> trim($_POST['asrmodel'])
		);
		saveRecognizeConf($asrsettings);
		
		// TTS
		$settings = array (
				"ttsapi" => trim($_POST['ttsapi']),
				"uri" => trim($_POST['uri']),
				"method" => trim($_POST['method']),
				"format" => trim($_POST['format']),
				"voice"  => trim($_POST['voice']),
				"speed"  => trim($_POST['speed']),
				"ssml"   => trim($_POST['ssml']),
				"cutprompt" => trim($_POST['cutprompt']),
				"maxage" => trim($_POST['maxage']),
				"id"     => trim($_POST['id']),
				"key"    => trim($_POST['key']),
				"user"   => trim($_POST['user']),
				"password" => trim($_POST['password'])
		);
		savePromptConf($settings);

		// Licence
		if (isset($_POST['license']) ) {
			$newkey = trim($_POST['licensekey']);
			// In case of remote lic => reset key to clear in file
			if (trim($_POST['license']) == "remote")
				$newkey="";
			modifyVoximalLicense($newkey);
		}

		// Google Credential
		if (isset($_POST['keyjson']) && isset($_POST['keyjson_update'])) {
			if ($_POST['keyjson_update'] == "updated") {
				$newkey = trim($_POST['keyjson']);
				saveVoximalGoogleCredit($newkey);
			}
		}
		VoxiFpbxLog("New configuration saved");
		needreload();
	}
	
	public function showPage() {
		/*debugjyg(" -------- Showpage");
		foreach($_REQUEST as $rk => $rv) {
			debugjyg("            $rk => $rv");
		}*/
		if(isset($_REQUEST['action'])) {
			if($_REQUEST['action'] == "delete") {
				//$this->delete($_REQUEST['id']);
				\needreload();
			} elseif($_REQUEST['action'] == "save") {
				$id = !empty($_REQUEST['id']) ? $_REQUEST['id'] : null;
				$goto = $_REQUEST[$_REQUEST['goto0'].'0'];
				//debugjyg("showPage: action=" .$_REQUEST['action']. " / display=".$_REQUEST['display']); 
			}
		}
		$view = !empty($_REQUEST['view']) ? $_REQUEST['view'] : "";
	
		$usage_list = '';
		switch($view) {
			case "editaccount":
				if(isset($_REQUEST['id'])) {
					//$usage_list = $this->FreePBX->View->destinationUsage(setcid_getdest($_REQUEST['id']));
					$item = $this->getAccountById($_REQUEST['id']);
				} else {
					$item = array(
						"id"   => '',
						"name" => ''
					);
				}
				$content = load_view(__DIR__."/views/editaccount.php",array("item" => $item));
			break;
			
			/*case "editfile":
				$content = load_view(__DIR__."/views/fileeditor.php",array("filename" => $_REQUEST['filename']));
				break;
			*/	
			default:
				$content = load_view(__DIR__."/views/appgrid.php",array());
			break;
		}
		return $content;
	}

	public function ajaxRequest($req, &$setting) {
	debugjyg("==== DBGJYG: ajaxRequest req=$req");
		switch($req) {
			case "getable":
			case "getfilelist":
			case "adddir":
			case "checkvxml":
			case "upload":
			return true;
			break;
		}
		return false;
	}

	public function ajaxHandler() {
		debugjyg("==== DBGJYG: ajaxHandler command=".$_REQUEST['command']);
		foreach($_REQUEST as $rk => $rv) {
			debugjyg("            $rk => $rv");
		}
		
		switch($_REQUEST['command']) {
			case "getable":
				$accounts = $this->getAllVoximalAccounts();
				foreach($accounts as &$account) {
					$account['actions'] = '<a href="?display=voximalapp&amp;view=editaccount&amp;id='.$account['id'].'">
												<i class="fa fa-edit"></i>
											</a> 
											<a href="?display=voximalapp&amp;action=delete&amp;id='.$account['id'].'" onclick="return confirm(\'Are you sure to remove this item ?\')">
												<i class="fa fa-trash"></i>
											</a>';
				}
				return $accounts;
				
			case "getfilelist":
				$root = "root";
				
				if (isset($_REQUEST['folder'])) {
					debugjyg("==== DBGJYG: ajax REQfolder=".$_REQUEST['folder']." root=".$_REQUEST['root']);
					// Treat case '..'
					if ($_REQUEST['folder'] == '..') {
						// Case first folder
						if (strpos($_REQUEST['root'], '/') !== false) {
							// remove last folder
							$inverse   = strrev($_REQUEST['root']);
							$newfolder = substr($inverse, strpos($inverse, '/')+1);
							$folder    = strrev($newfolder);
							debugjyg("==== DBGJYG: ajax inverse=$inverse newfolder=$newfolder folder=$folder");
						}
						else {
							// First Folder no '/'
							$folder = "";
						}
					}
					else {
						if (isset($_REQUEST['root']) && !empty($_REQUEST['root']) && $_REQUEST['root'] != 'root') {
							$folder = $_REQUEST['root'] . "/" . $_REQUEST['folder'];
						}
						else  {
							$folder = $_REQUEST['folder'];
						}
					}
					if ($folder != "")
						$root = $folder;
					else 
						$root = "root";
				}
				else {
					$folder = "";
				}
				$filepath = "";
				if (isset($_REQUEST['filepath'])) {
					$filepath = $_REQUEST['filepath'];
				};
				debugjyg("==== DBGJYG: ajax folder=$folder filepath=$filepath");
				$fileslist = $this->getVxmlFilesList($folder, $filepath);
	//print_r($fileslist);
				/* Returned list contain followed infos :
						- modified => Nov 19 2018 6:31 PM
						- size => 177
						- filename => phone.vxml
						- type => VoiceXML File
						- editable => 1
				 */
				foreach($fileslist as &$file) {
					//foreach($file as $k => $v) { debugjyg(" $k => $v");}
					$paramurl = "";
					if (isset($_REQUEST['folder'])) {
						$paramurl = "&amp;folder=" . $_REQUEST['folder'] . "&amp;root=".$_REQUEST['root'];
						if (!empty($filepath)) {
							$paramurl .= "&filepath=$filepath";
						}
					}
					if ($file['editable']) {
						/*$file['actions'] = '<a href="?display=voximalfilemanager&amp;view=editfile&amp;filename='.$file['filename'].'"><i class="fa fa-edit"></i></i></a> <a href="?display=voximalapp&amp;action=delete&amp;filename='.$file['filename'].'"><i class="fa fa-trash"></i></a>';*/
						//$file['actions'] = '<a href="#" role="button" class="fa fa-edit" data-toggle="modal" data-target="#popupeditor" data-type="files" data-section="files" data-url="ajax.php?module=voximal&command=editfile&file='.$file['filename'].'">';
						//$file['actions'] = '<a href="#" onclick="editfile(\''.$file['filename']. '\')" style="cursor:pointer;" data-toggle="modal" ><i class="fa fa-edit"></i></a>';
						/// $file['actions'] = '<a href="?display=voximalfilemanager&amp;action=editfile&amp;filename='.$file['filename'].'&amp;path='.$root.'"><i class="fa fa-edit"></i></a><a href="?display=voximal&amp;action=delete&amp;filename='.$file['filename'].'" onclick="return confirm(\'Are you sure to remove this item ?\')"><i class="fa fa-trash"></i></a>';
						
						$file['actions'] = '<a href="?display=voximalfilemanager&amp;action=editfile&amp;filename='.$file['filename']. $paramurl.'">
												<i class="fa fa-edit"></i>
											</a>
											<a href="?display=voximalfilemanager&amp;action=delete&amp;filename='.$file['filename']. $paramurl.'" onclick="return confirm(\'Are you sure to remove this item ?\')">
												<i class="fa fa-trash"></i>
											</a>
											<a href="?display=voximalfilemanager&amp;action=download&amp;filename='.$file['filename'].'&filepath='.$filepath.'">
												<i class="fa fa-download" alt="Download"></i>
											</a>
											';
						//Add link on filename
						$file['filename'] = '<a href="?display=voximalfilemanager&amp;action=editfile&amp;filename='.$file['filename']. $paramurl.'">'.$file['filename'].'</a>';
					}
					else if ($file['downloadable']){
						if ($file['filename'] != '..') {
							$file['actions'] = '<a href="?display=voximalfilemanager&amp;action=delete&amp;filename='.$file['filename']. $paramurl.'" onclick="return confirm(\'Are you sure to remove this item ?\')"><i class="fa fa-trash"></i></a>
							<a href="?display=voximalfilemanager&amp;action=download&amp;filename='.$file['filename'].'&filepath='.$filepath.'"><i class="fa fa-download" alt="Download"></i></a>';
						}
					}
					else {
						if ($file['filename'] != '..')
							$file['actions'] = '<a href="?display=voximalfilemanager&amp;action=delete&amp;filename='.$file['filename']. $paramurl.'" onclick="return confirm(\'Are you sure to remove this item ?\')"><i class="fa fa-trash"></i></a>';
					}
					if ($file['type'] == "directory") {
						$localurl = '?display=voximalfilemanager&amp;folder='.$file['filename'].'&amp;root='.$root;
						if (!empty($filepath)) {
							$localurl .= "&filepath=$filepath";
						}
						$file['type']     = '<a href="'.$localurl.'">directory</a>';
						$file['filename'] = '<a href="'.$localurl.'">'.$file['filename'].'</a>';
					}
						
				}
				return $fileslist;
				break; // eof 'getfilelist'
			
			case "adddir":
				$this->addDirectory($_REQUEST);
				return array('status' => true);
				break;

			case "addfile":
				$this->addFile($_REQUEST);
				return array('status' => true);
				break;
			
			case "checkvxml":
				debugjyg("==== DBGJYG: ajax checkvxml");
				if (isset($_REQUEST['code'])) {
					$ret = $this->checkVxmlCode($_REQUEST['code']);
					if ($ret == "ok") {
						return array('status' => true, 'result' => 'The Vxml syntax is valid');
					}
					else {
						return array('status' => false, 'result' => $ret);
					}
				}
				else {
					return array('status' => false, 'result' => 'no code found');
				}
				break; // eof 'checkvxml'
				
			case "upload":
				//debugjyg("==== DBGJYG: upload nb files ". count($_FILES["files"]["name"]));
				foreach ($_FILES["files"]["error"] as $key => $error) {
					//debugjyg("==== DBGJYG: key=$key error=$error : ".$_FILES["files"]["name"][$key]);
					$uploadstatus = true;
					switch($error) {
						case UPLOAD_ERR_OK:
							$extension = pathinfo($_FILES["files"]["name"][$key], PATHINFO_EXTENSION);
							$extension = strtolower($extension);
							////$supported = $this->FreePBX->Media->getSupportedFormats();
							debugjyg("          extension=$extension");
							$supported = array("vxml","c","txt","wav","tpl");
							if(in_array($extension, $supported)) {
								$pathfile = WEBDIR;
								//if (isset($_REQUEST['filepath']) && ($_REQUEST['filepath'] == "audio")) {
								//	$pathfile = AUDIODIR;
								//}
								if (isset($_REQUEST['filepath'])) {
									$pathfile = $this->getBaseAllowedPath($_REQUEST['filepath']);
								}
								
								if (isset($_REQUEST['folder']) && ($_REQUEST['folder'] != "")) {
									if (isset($_REQUEST['root']) && ($_REQUEST['root'] != "root")) {
										$pathfile .= $_REQUEST['root'] . "/";
									}
									$pathfile .= $_REQUEST['folder'] . "/";
								}
								$pathfile .= $_FILES["files"]["name"][$key];
								$tmp_name = $_FILES["files"]["tmp_name"][$key];
								debugjyg("          save $tmp_name -> $pathfile");
								move_uploaded_file($tmp_name, $pathfile);
								VoxiFpbxLog($pathfile . " uploaded");
							}
							else {
								debugjyg("          unsupported extension $extension !!");
							}
							break;
						case UPLOAD_ERR_INI_SIZE:
							$uploadstatus = false; $message = _("The uploaded file exceeds the upload_max_filesize directive in php.ini");
							break;
						case UPLOAD_ERR_FORM_SIZE:
							$uploadstatus = false; $message = _("The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form");
							break;
						case UPLOAD_ERR_PARTIAL:
							$uploadstatus = false; $message = _("The uploaded file was only partially uploaded");
							break;
						case UPLOAD_ERR_NO_FILE:
							$uploadstatus = false; $message = _("No file was uploaded");
							break;
						case UPLOAD_ERR_NO_TMP_DIR:
							$uploadstatus = false; $message = _("Missing a temporary folder");
							break;
						case UPLOAD_ERR_CANT_WRITE:
							$uploadstatus = false; $message = _("Failed to write file to disk");
							break;
						case UPLOAD_ERR_EXTENSION:
							$uploadstatus = false; $message = _("A PHP extension stopped the file upload");
							break;
						default:
							debugjyg("==== DBGJYG: unsupported error=$error");
							$uploadstatus = false; $message = "unsupported error=$error";
							break;
					}
				}
				//debugjyg("==== DBGJYG: Can Not Find Uploaded Files");
				//return array("status" => false, "message" => _("Can Not Find Uploaded Files"));
				if ($uploadstatus) {
					return array("status" => true, "filename" => "/tmp/filename", "localfilename" => "localfilename", "id" => "id");
				}
				else {
					debugjyg("             Failed to upload : $message");
					VoxiFpbxLog("Failed to upload file : $message");
					return array("status" => $uploadstatus, "message" => $message);
				}
				break; // eof 'upload'
			
			default:
				debugjyg("==== DBGJYG: unsupported command ".$_REQUEST['command']);
				return array("status" => false, "message" => "unsupported command ".$_REQUEST['command']);
				break;
		}
	}
	
	public function genConfig() {
		$retvar['voximal.conf']['general']['debug'] = "valuejy";
//debugjyg("==== DBGJYG: genConfig() called!");
		return $retvar;
	}

	public function writeConfig($config) {
//debugjyg("==== DBGJYG: writeConfig() called!");
		// Call function to write voximal.conf file
		writeVoximalConf();
	}
	
	
	public function getAllVoximalAccounts() {
		$sql = "SELECT * FROM voximal ORDER BY name";
		//$sql = "SELECT cid_id, description, cid_name, cid_num, dest FROM setcid ORDER BY description ";
		$sth = $this->db->prepare($sql);
		$sth->execute();
		$results = $sth->fetchAll(\PDO::FETCH_ASSOC);
		return !empty($results) ? $results : array();
	}
	function getAccountById($id) {
		$sql = "SELECT * FROM voximal WHERE id='$id'";
		$sth = $this->db->prepare($sql);
		$sth->execute();
		$results = $sth->fetchAll(\PDO::FETCH_ASSOC);
		return !empty($results) ? $results[0] : array();
	}
	
	function delAccountById($id) {
		$sql = "DELETE FROM voximal WHERE id='$id'";
		$db      = \FreePBX::Database();
		$prep    = $db->prepare($sql);
		$results = $prep->execute();
    
		/*$sth = $this->db->prepare($sql);
		$sth->execute();
		$results = $sth->fetchAll(\PDO::FETCH_ASSOC);*/
		return !empty($results) ? $results[0] : array();
	}
	
	function addAccount($voximal) {
		$list_fields = array("name",    "number",    "url",      "maxsessions", "dialformat",
							 "mark", "maxtime", "vxmlparam","startdelay", "speech", "speechprovider", "goto");
		$lastkey = "goto";

		/*$voximallist = getVoximalList("*");
		$id = count($voximallist) + 1;*/
		//$sql = 'INSERT INTO voximal VALUES ("'.$id.'","'.$voximal['name'].'","'.$voximal['url'].'","'.$voximal['maxsessions'].'","'.$voximal['dialformat'].'","'.$voximal['mark'].'","'.$voximal['speech'].'","'.$voximal['speechprovider'].'","'.$voximal['goto'].'")';
		$sql = 'INSERT INTO voximal (';
		foreach($list_fields as $key){
			if ($key == $lastkey)
				$sql .= $key;
			else
				$sql .= $key. ',';
		}
		$sql .= ') VALUES (';
		foreach($list_fields as $key){
			if ($key == $lastkey)
				$sql .= '"' .$voximal[$key]. '"';
			else
				$sql .= '"' .$voximal[$key]. '",';
		}
		$sql .= ');';
//echo "SQLREQ=$sql<br>";

		$db      = \FreePBX::Database();
		$ins     = $db->prepare($sql);
		$results = $ins->execute();
    
	/*
		$sth = $this->db->prepare($sql);
		$sth->execute();
		try {
			$results = $sth->fetchAll(); // (\PDO::FETCH_ASSOC);
		}
		catch (Exception $e) {
			debugjyg("Voximal:Exception:addAccount:".$e->getMessage());
		}*/
		VoxiFpbxLog("Account '".$voximal["name"] . "' added");
		return !empty($results) ? $results[0] : array();
	}



	/*
	public function getActionBar($request) {
		$buttons = array();
		if($request['display'] == 'voximalapp' && isset($request['view'])) {
			switch($request['view']) {
				case 'editaccount':
					$buttons = array(
						'delete' => array(
							'name' => 'delete',
							'id' => 'delete',
							'value' => _('Delete')
						),
						'reset' => array(
							'name' => 'reset',
							'id' => 'reset',
							'value' => _('Reset')
						),
						'submit' => array(
							'name' => 'submit',
							'id' => 'submit',
							'value' => _('Submit')
						)
					);
				break;
			}
		}
		if(empty($request['id'])) {
			unset($buttons['delete']);
		}
		return $buttons;
	}*/
	public function getActionBar($request) {
		$buttons = array();
		switch($request['display']) {
			case 'voximalsettings':
				$buttons = array(
					'reset' => array(
						'name' => 'reset',
						'id' => 'reset',
						'value' => _('Reset')
					),
					'submit' => array(
						'name' => 'submit',
						'id' => 'submit',
						'value' => _('Submit')
					)
				);
			break;
			
			case 'voximalapp':
				if (isset($request['view'])) {
					switch($request['view']) {
						case 'editaccount':
							$buttons = array(
								'cancel' => array(
									'name' => 'cancel',
									'id' => 'cancel',
									'onClick' => 'cancelClickHandler()',
									'value' => _('Cancel')
								),
								'delete' => array(
									'name' => 'delete',
									'id' => 'delete',
									'value' => _('Delete')
								),
								'reset' => array(
									'name' => 'reset',
									'id' => 'reset',
									'value' => _('Reset')
								),
								'submit' => array(
									'name' => 'submit',
									'id' => 'submit',
									'value' => _('Submit')
								)
							);
						break;
					}
				}
				if(empty($request['id'])) {
					unset($buttons['delete']);
				}			
			break;
			
			case 'voximalfilemanager':
				if (isset($request['action']) && ($request['action'] == 'editfile')) {
					$buttons = array(
						'cancel' => array(
							'name' => 'cancel',
							'id' => 'cancel',
							'onClick' => 'cancelClickHandler()',
							'value' => _('Cancel')
						),

						'submit' => array(
							'name' => 'submit',
							'id' => 'submit',
							'value' => _('Submit')
						)
					);
					// add Check button just for vxml extension
////				if (is_executable("vxmlvalidator")) {
						if (isset($request['filename'])) {
							$elts = explode(".", $request['filename']);
							if (isset($elts[1]) && ($elts[1]=="vxml")) {
								$buttons['checkvxml' ] = array( 'type' => 'button',
																'name' => 'checkvxml',
																'id' => 'checkvxml',
																'onClick' => 'checkVxmlClickHandler()',
																'value' => _('Check')  );
							}
						}
	///				}
				}
			break;
		}
		return $buttons;
	}

	public function getRightNav($request) {
	  if(isset($request['view']) && $request['view'] == 'editaccount'){
	    return load_view(__DIR__."/views/rnav.php",array());
	  }
	}
	
	
	// Return the base path authorized => defined in voximal-def.inc
	//     in: $path   : name of known path base
	//                   PATH_VXML / PATH_AUDIO / PATH_VALUE_VOXICFG / PATH_VALUE_VOXIVXML
	public function getBaseAllowedPath($filepath) {
		// By default the base path is PATH_VXML /var/www/html/vxml
		$directory = WEBDIR;
		
		foreach (\Constants::$vFilemanager_pathlist as $k => $elt_fm) {
			//debugjyg("getBaseAllowedPath: search $filepath : ".$elt_fm["value"]);
			if ($filepath == $elt_fm["value"]) {
				$directory = $elt_fm["path"];
				return $directory;
			}
		}
		return $directory;
	}
	
	// Return file list of a folder
	//     in: $reqdir : folder to list
	//         $path   : name of known path base => defined in voximal-def.inc
	//                   PATH_VXML / PATH_AUDIO / PATH_VALUE_VOXICFG / PATH_VALUE_VOXIVXML
	// Return an array with file list
	//     results['filename'] : array of filenames
	//     results['type']     : array of type
	//     results['size']     :
	//     results['modified'] :
	public function getVxmlFilesList($reqdir = "", $path) {
	
		// Sometimes you may need to hide sensitive files. Add them here
		$files_to_skip = array(
			'.',
		);
//echo "getVxmlFilesList=$reqdir<br>";


		// check if we are in root
		if ($reqdir == "") {
			$files_to_skip[] = '..';
		}
		
		//WEBDIR='/var/www/html/vxml';
		// by default 
		if (isset($path) && !empty($path) ) {
			$base = $this->getBaseAllowedPath($path);
			$directory = $base . "/" .$reqdir;
			if (!file_exists($directory)) {
				$directory = $base;
			}
		}
		else {
			$directory = WEBDIR . "/" .$reqdir;  // WEBDIR . "/" .$reqdir;
			if (!file_exists($directory)) {
				$directory = WEBDIR;
			}
		}
		//debugjyg("getVxmlFilesList: $path parse: $directory");
		
		$myDirectory=opendir($directory);
		if (is_dir($directory)) {
			$result = array();
			$files = array_diff(scandir($directory), $files_to_skip);
			foreach($files as $entry) if($entry !== basename(__FILE__)) {
				$i = $directory . '/' . $entry;
				$stat = stat($i);
				if (is_dir($i)) {
					$filetype    = "directory";
					$fileditable = false;
					$downloadable = false;
				}
				else {
					$filetype = $this->getFileType($entry, $fileditable, $downloadable);
				}
				$result[] = array(
					'modified' 	=> date("M j Y g:i A", filemtime($i)),  // $stat['mtime'],
					'size' 		=> $stat['size'],
					'filename' 	=> basename($i),
					'type' 		=> $filetype,
					'editable'  => $fileditable,
					'downloadable'  => $downloadable,
				);
				
				//echo "name=".basename($i)." type=".$this->getFileType($entry)." modified=".$stat['mtime']." size=".$stat['size']." entry=".$entry."<br>";
			}
		} 
		return $result;
	}
	
	// Return file type
	function getFileType($file, &$edit, &$downloadable) {
		$extn = $this->findexts($file);
		$edit = false;
		switch ($extn){
			case "png": $extn="PNG Image"; $downloadable = true; break;
			case "jpg": $extn="JPEG Image"; $downloadable = true; break;
			case "svg": $extn="SVG Image"; $downloadable = true; break;
			case "gif": $extn="GIF Image"; $downloadable = true; break;
			case "ico": $extn="Windows Icon"; $downloadable = true; break;
			case "txt": $extn="Text File"; $edit = true; $downloadable = true; break;
			case "log": $extn="Log File"; $edit = true; $downloadable = true; break;
			case "html": $extn="HTML File"; $edit = true; $downloadable = true; break;
			case "php": $extn="PHP Script"; $edit = true; $downloadable = true; break;
			case "js": $extn="Javascript"; $edit = true; $downloadable = true; break;
			case "css": $extn="Stylesheet"; $edit = true; $downloadable = true; break;
			case "conf": $extn="Configuration File"; $edit = true; $downloadable = true; break;
			case "xml": $extn="XML File"; $edit = true; break;
			case "vxml": $extn="VoiceXML File"; $edit = true; $downloadable = true; break;
			case "grxml": $extn="Grammar File"; $edit = true; $downloadable = true; break;
			case "gram": $extn="Grammar File"; $edit = true; $downloadable = true; break;
			case "srgs": $extn="Grammar File"; $edit = true; $downloadable = true; break;
			case "aiml": $extn="AIML File"; $edit = true; $downloadable = true; break;
			case "sh": $extn="Script File"; $edit = true; $downloadable = true; break;
			case "ini": $extn="Configuration File"; $edit = true; $downloadable = true; break;
			case "tpl": $extn="TPL File"; $edit = true; $downloadable = true; break;
			case "pdf": $extn="PDF Document"; $downloadable = true; break;
			case "zip": $extn="ZIP Archive"; $downloadable = true; break;
			case "bak": $extn="Backup File"; $edit = true; $downloadable = true; break;
			case "wav": $extn="WAV File"; $play = true; $downloadable = true; break;
			case "gsm": $extn="GSM File"; $play = true; $downloadable = true; break;
			case "mp3": $extn="MP3 File"; $play = true; $downloadable = true; break;

			//case "mp4": $extn="MP4 File"; $video = 1; break;
			//case "h263": $extn="H263 File"; $video = 1; break;

			default: $extn=strtoupper($extn)." File"; break;
		}

		return $extn;
	}
	
	// Return extension
	function findexts ($filename) {
		$filename=strtolower($filename);
		$exts=explode(".", $filename);
		$n=count($exts)-1;
		$exts=$exts[$n];
		return $exts;
	}
	
	// Create VXML folder
	function addDirectory ($dir) {
		exec("mkdir -p $dir");
		exec("chown -R asterisk. $dir");
		VoxiFpbxLog($dir . " added");
		return;
	}
	
	// Create VXML file
	function addFile ($filename) {
		exec("touch $filename");
		exec("chown asterisk. $filename");
		VoxiFpbxLog($filename . " added");
		return;
	}

	// Delete VXML folder
	function delDirectory ($request) {
		$dir = isset($request['dir']) ? realpath(WEBDIR.$request['dir']) : realpath(WEBDIR);
		//echo "dir=$dir / newfoldername=".$request['newfoldername']."<br>";
		exec("mkdir -p $dir/".$request['newfoldername']);
		exec("chown -R asterisk. $dir/".$request['newfoldername']);
		VoxiFpbxLog("$dir/".$request['newfoldername'] . " created");
		return;
	}
	
	// Delete VXML folder
	function delVxmlFile ($filename) {
		if (file_exists($filename)) {
			exec("rm -rf $filename");
			VoxiFpbxLog($filename . " removed");
		}
		return;
	}

	function saveEditedFile($file, $content) {
		file_put_contents("/tmp/tmpEditedFile",ltrim($content));
        exec("mv ".$file." ".$file.".bak");
        exec("mv /tmp/tmpEditedFile ".$file);
	    exec("chown asterisk. ".$file);
		VoxiFpbxLog($file . " saved");
        //echo "save file to " .$_POST['editedFile'];
	}
	
	function checkVxmlCode($code) {
		file_put_contents("/tmp/tmpCheckedFile",ltrim($code));
        exec(VXML_VALIDATOR . " /tmp/tmpCheckedFile", $output, $mVxmlValidationResultCode);
        ///echo "Validator tmp file! retexec='$retval' <br>";
        //print_r($output) ;
        //$mVxmlValidation = true;
		debugjyg("====         checkVxmlCode ret=".$mVxmlValidationResultCode." ".count($output));
		if (isset($output)) {
			if (is_array($output)) {
				foreach ($output as $k => $v) {
					debugjyg("output: $k => $v");
				}
			}
			else {
				debugjyg("No output for vxmlvalidator".$output);
			}
		}
		
		if ($mVxmlValidationResultCode==0) {
            $mVxmlValidationResult = "ok";
        }
        else {
			if (count($output)) {
				$mVxmlValidationResult = $this->parseVxmlValidatorResult($output);
			}
			else {
				$mVxmlValidationResult = "Failed to Valid Vxml syntaxe";
			}
        }
		return $mVxmlValidationResult;
	}
	
	/**
	 * Output result of Vxmlvalidator cmd
	 *  In case of valid script => line is  : VALID: <file>
	 *  In case of errors :
	 *          INVALID: /tmp/tmpEditedFile
	 *          Info: DocumentParser::FetchDocument - Loading grammar: http://www.w3.org/TR/voicexml21/vxml.xsd
	 *          Error (module='com.speechworks.vxi' id='990') : URL='/tmp/tmpEditedFile'
	 *          Info: DocumentParser::FetchDocument - Parse error in file "/tmp/tmpEditedFile", line 15, column 5 - Expected end of tag 'prompt'
	 *
	 *          TIME PROCESSING: 24359
	 *
	 *          PAGES PARSED: 1 (41.0526 p/s)
	 *
	 */
	function parseVxmlValidatorResult($array_result) {
		$retval="";
		$startCheck=false;
		foreach ($array_result as $line) {
			if (preg_match("/^VALID/", $line)) {
				$retval = "VoiceXML syntax is valid.";
				break;
			}
			else if (preg_match("/^INVALID/", $line)) {
				$startCheck=true;
				$retval = "INVALID VoiceXML syntax :<br>";
				continue;
			}
			else if (preg_match("/^TIME PROCESSING/", $line))
				break;

			if ($startCheck) {
				//$line = str_replace("/tmp/tmpCheckedFile", "edited file", $line);
				if (!(preg_match("/Loading grammar/", $line) || preg_match("/com.speechworks.vxi/", $line))) {
					$line = str_replace("Info: DocumentParser::FetchDocument - ", "", $line);
					$line = str_replace('in file "/tmp/tmpCheckedFile", ', ": ", $line);
					$retval .= $line . "<br>";
				}
			}
		}
		return $retval;
	}

}
