<?php
// File    : page.voximalstatus.php
// Version : $Revision: 1.11 $

namespace FreePBX\modules;


function getOutput($command){
	global $astman;
	$response  = $astman->send_request('Command',array('Command'=>$command));
	$new_value = htmlentities($response['data'],ENT_COMPAT | ENT_HTML401, "UTF-8");
	return ltrim($new_value,'Privilege: Command');
}



//Check if user is "logged in"
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed'); }

$extdisplay = !empty($_REQUEST['extdisplay'])?$_REQUEST['extdisplay']:'summary';


global $astman;
$license = $astman->send_request('Command',array('Command'=>"voximal show license"));
$license = explode("\n",$license['data']);

// Get max sessions and config
foreach ($license as $line) {
	if (strpos($line,":") !== false) {
		list($key, $val) = explode(":", $line);
		$license_infos[rtrim(ltrim($key))] = trim(ltrim($val));
	}
}
$listModEnable = "VoiceXML";
if ($license_infos["TextToSpeech"] == "Yes")
	$listModEnable .= " - TTS";
if ($license_infos["Speech"] == "Yes")
	$listModEnable .= " - ASR";

$max_sessions = $license_infos["Max sessions"];


// Get license info
$licExpired        = false;
$licWithExpiration = false;
$license_state     = $license_infos["State"];

// Check expiration date
if (isset($license_infos["Expiration"])) {
    $elts       = explode(" ", $license_infos["Expiration"]);
    $expdate    = $elts[0];
    $now        = new DateTime(date("Y-m-d")); //date('Y-m-d'));
    $expiration = new DateTime($expdate); //$elt["last_req"]);
    $interval   = $now->diff($expiration);
     // pour avoir le nb de jours de diff avec signe : $interval->format('%R%a')
    $nbDayDiff = $interval->format('%R%a');

    if ($nbDayDiff <= 0) {
        $licExpired		= true;
		$license_state  = _("Expired");
	}
    else {
        $licWithExpiration = true;
		$license_state     = _("Expiration");
	}
}

// Get voximald state
$out = shell_exec("pidof voximald | wc -w");
if ($out == 0) {
	$voximald_state = 'Not running';
}
else {
	$voximald_state = 'Running';
}


/*
 echo $voximalstatushtml
 echo $dateshtml
 echo $versionhtml
 echo $statisticshtml
 echo $configurationhtml
*/
$summary	= _("Summary");
$voxidates 	= _("Dates");
$voxistatus	= _("Status");
$voxiversion= _("Version");
$voxiconfig	= _("Configuration");
$voxistats	= _("Statistics");
$voxilicense= _("License");

$modes = array(
	"summary"		=> $summary,
	"voxiversion"	=> $voxiversion,
	"voxidates"		=> $voxidates,
	"voxilicense"	=> $voxilicense,
	"voxiconfig"	=> $voxiconfig,
	"voxistats"		=> $voxistats,
);

//Make sure "ALL" is the last item.
///$modes["all"] = _("All");

// show dates
//$dateshtml = '<h2>'.$voxidates.'</h2>';
$output    = getOutput("voximal show dates");
$dateshtml .= load_view(__DIR__.'/views/panel.php', array('title' => $voxidates, 'body' => $output));

// show Version
//$versionhtml = '<h2>'.$voxiversion.'</h2>';
$output = '';
$output = getOutput("voximal show version");
$versionhtml .= load_view(__DIR__.'/views/panel.php', array('title' => $voxiversion, 'body' => $output));

// show Configuration
//$confightml = '<h2>'.$voxiconfig.'</h2>';
$output = '';
$output = getOutput("voximal show configuration");
$confightml .= load_view(__DIR__.'/views/panel.php', array('title' => $voxiconfig, 'body' => $output));

// show License
//$confightml = '<h2>'.$voxiconfig.'</h2>';
$output = '';
$output = getOutput("voximal show license");
$licensehtml .= load_view(__DIR__.'/views/panel.php', array('title' => $voxilicense, 'body' => $output));

// show statistics
//$confightml = '<h2>'.$voxiconfig.'</h2>';
$output = '';
$output = getOutput("voximal show statistics");
$statshtml .= load_view(__DIR__.'/views/panel.php', array('title' => $voxistats, 'body' => $output));


// Create summary page
$summarypage = "
Process       : $voximald_state
License       : $license_state
Options       : $listModEnable
Max sessions  : $max_sessions
";
$summaryhtml .= load_view(__DIR__.'/views/panel.php', array('title' => "Summary", 'body' => $summarypage));

?>

<div class="container-fluid">
	<h1><?php echo _("Voximal status")?></h1>
	<?php /* echo (!$astman)?$amerror:''; */?>
	<div class = "display full-border">
		<div class="row">
			<div class="col-sm-9">
					<div class="fpbx-container">
						<div class="tab-content display full-border">
							<div role="tabpanel" id="summary" class="tab-pane active">
								<?php echo $summaryhtml?>
							</div>
							<div role="tabpanel" id="voxiversion" class="tab-pane">
								<?php echo $versionhtml?>
							</div>
							<div role="tabpanel" id="voxidates" class="tab-pane">
								<?php echo $dateshtml?>
							</div>
							<div role="tabpanel" id="voxilicense" class="tab-pane">
								<?php echo $licensehtml?>
							</div>
							<div role="tabpanel" id="voxiconfig" class="tab-pane">
								<?php echo $confightml?>
							</div>
							<div role="tabpanel" id="voxistats" class="tab-pane">
								<?php echo $statshtml?>
							</div>
							<?php echo $hooktabs ?>
							<div role="tabpanel" id="all" class="tab-pane">
								<?php echo $summaryhtml ?>
								<?php echo $dateshtml ?>
								<?php echo $versionhtml ?>
								<?php echo $licensehtml?>
								<?php echo $confightml?>
								<?php echo $statshtml?>
							</div>
						</div>
					</div>
				</div>
				<div class="col-sm-3 bootnav">
					<div class="list-group">
						<?php echo load_view(__DIR__.'/views/bootnav.php', array('modes' => $modes, 'extdisplay' => $extdisplay)); ?>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
