<?php
// File    : asr.voximalsettings.php
// Version : $Revision: 1.10 $


//Bind with jaavscript this value
$workingASR=getWorkingASR();



// GEt voximal configuration
$settings = getRecognizeConf(true);

$settings['asrapi']		= $settings['api']	;
$settings['asruri']		= $settings['uri']	;
$settings['asrmethod']	= $settings['method'];	
$settings['asrformat']	= $settings['format'];	
$settings['asrid']		= $settings['id']	;	
$settings['asrkey']		= $settings['key']	;	
$settings['asruser']	= $settings['user']	;
$settings['asrpassword']= $settings['password'];
$settings['asrmodel']	= $settings['model']	;
//echo "<br>getRecognizeConf<br>";
//print_r($settings);
				
//debug
/*
if(count($_POST))
echo "<pre>POST\n".print_r($_POST,true)."</pre>";
echo "<pre>Settings\n".print_r($settings,true)."</pre>";
 */

//Apis
$asr_apis=array(
//	'HTTP connecto'=>'default',
	'Asterisk'=>'asterisk',
	'Microsoft Bing Speech API'=>'microsoft',
//	'Voximal'=>'voximal',
	'IBM/Watson Speech to Text'=>'watson',
	'Google Speech API'=>'google',
	'Google Speech API (streaming)'=>'google_streaming',
	'Google Dialogflow API (streaming)'=>'google_dialogflow',
	);

//We check the value of Method
if (trim($settings['asrmethod']) == "ASTERISK") {
	$method_asterisk   = "checked";
	$method_post       = "";
	$method_get        = "";
}
else if (trim($settings['asrmethod']) == "POST") {
	$method_asterisk   = "";
	$method_post       = "";
	$method_get        = "checked";
}
else {
	$method_asterisk   = "";
	$method_post       = "checked";
	$method_get        = "";
}
//Add format changing only this array
$asr_formats=array('wav'=>'','wav16'=>'','pcm'=>'','alaw'=>'','ulaw'=>'','raw'=>'','sln'=>'','sln16'=>'');
foreach($asr_formats as $asrf => $val){
	if (trim($settings['format']) == $asrf){
		$asr_formats[$asrf]='checked';
	}else{
		$asr_formats[$asrf]='';
	}
}

$tabindex = 0;

/*
$tab_keyjson = getVoximalGoogleCredit();
$keyjson     = $tab_keyjson['credkey'];
*/
$keyjson     = getVoximalGoogleCredit();

?>

<div id="voximalcfg_asr" class="tab-pane">
<input type="hidden" id="workingASR" name="workingASR" value="<?php echo $workingASR ?>">

<!--ASR API -->
<div class="element-container">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="asrapi"><?php echo _("API") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="asrapi"></i>
					</div>
						<div class="col-md-9">
							<select id="asrapi" name="asrapi" class="form-control" onchange="onApiChangeAsr()" >
							<?php
								foreach ( $asr_apis as $ApiName=>$ApiCode ){ ?>
								
								<option value="<?php echo $ApiCode;?>" <?php echo $settings['asrapi']== $ApiCode?"selected":""?>><?php echo $ApiName?></option>
							<?php } ?>
							</select>
						</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="asrapi-help" class="help-block fpbx-help-block"> <?php echo _("Text To Speech API to use."); ?></span>
		</div>
	</div>
</div>
<!-- ASR API  -->
<!-- URI -->
<div class="element-container" id="eltcont_asruri">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="asruri"><?php echo _("URI") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="asruri"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="text" class="form-control" id="asruri" name="asruri" value="<?php echo isset($settings['asruri'])?$settings['asruri']:''?>">
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="asruri-help" class="help-block fpbx-help-block"> <?php echo _("URI used."); ?></span>
		</div>
	</div>
</div>
<!--END URI-->
<!-- Method -->
<div class="element-container" id="eltcont_asrmethod">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="asrmethod"><?php echo _("Method") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="asrmethod"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="radio" name="asrmethod" id="asrmethod_post" value="POST" <?php echo $method_post ?>>
						<label for="asrmethodpost"><?php echo _("POST");?></label>
						<input type="radio" name="asrmethod" id="asrmethod_get" value="GET" <?php echo $method_get ?>>
						<label for="asrmethodget"><?php echo _("GET");?></label>
						<input type="radio" name="asrmethod" id="asrmethod_asterisk" value="ASTERISK" <?php echo $method_asterisk ?>>
						<label for="asrmethodasterisk"><?php echo _("ASTERISK");?></label>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="asrmethod-help" class="help-block fpbx-help-block"><?php echo _("HTTP asrmethod, or set Asterisk to send the text to the Asterisk module.")?></span>
		</div>
	</div>
</div>
<!--END Method -->
<!-- Format -->
<div class="element-container"  id="eltcont_asrformat">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="asrformat"><?php echo _("Format") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="asrformat"></i>
					</div>
					<div class="col-md-9 radioset">
						<?php
						foreach($asr_formats as $asrf => $checked){ ?>
						<input type="radio" name="asrformat" id="asrformat_<?php echo $asrf?>" value="<?php echo $asrf?>" <?php echo $checked?> tabindex="<?php echo $tabindex++?>">
						<label for="asrformat_<?php echo $asrf?>"><?php echo $asrf?></label>
						<?php }?>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="asrformat-help" class="help-block fpbx-help-block"><?php echo _("Format expected for audio files.")?></span>
		</div>
	</div>
</div>
<!--END Format -->
<!-- ASR ID -->
<div class="element-container"  id="eltcont_asrid">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="asrid"><?php echo _("ID") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="asrid"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="text" class="form-control" id="asrid" name="asrid" value="<?php echo isset($settings['id']) ? $settings['id'] : ''?>">
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="asrid-help" class="help-block fpbx-help-block"> <?php echo _("Define id parameter for specific asrapi."); ?></span>
		</div>
	</div>
</div>
<!--END ASR ID -->
<!-- TTS KEY -->
<div class="element-container"  id="eltcont_asrkey">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="asrkey"><?php echo _("Key") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="asrkey"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="text" class="form-control" id="asrkey" name="asrkey" value="<?php echo isset($settings['asrkey']) ? $settings['asrkey'] : ''?>">
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="asrkey-help" class="help-block fpbx-help-block"> <?php echo _("Define asrkey parameter for specific asrapi."); ?></span>
		</div>
	</div>
</div>
<!--END TTS KEY -->
<!-- TTS USER -->
<div class="element-container"  id="eltcont_asruser">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="asruser"><?php echo _("User") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="asruser"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="text" class="form-control" id="asruser" name="asruser" value="<?php echo isset($settings['asruser']) ? $settings['asruser'] : ''?>">
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="asruser-help" class="help-block fpbx-help-block"> <?php echo _("Define User parameter for specific asrapi."); ?></span>
		</div>
	</div>
</div>
<!--END TTS USER -->
<!-- TTS Password -->
<div class="element-container" id="eltcont_asrpassword" >
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="asrpassword"><?php echo _("Password") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="asrpassword"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="text" class="form-control" id="asrpassword" name="asrpassword" value="<?php echo isset($settings['asrpassword']) ? $settings['asrpassword'] : ''?>">
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="asrpassword-help" class="help-block fpbx-help-block"> <?php echo _("Define Password parameter for specific asrapi."); ?></span>
		</div>
	</div>
</div>
<!--END TTS Password -->
<!-- Model -->
<div class="element-container" id="eltcont_asrmodel" >
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="asrmodel"><?php echo _("Model") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="asrmodel"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="text" class="form-control" id="asrmodel" name="asrmodel" value="<?php echo isset($settings['asrmodel']) ? $settings['asrmodel'] : ''?>">
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="asrmodel-help" class="help-block fpbx-help-block"> <?php echo _("Define asrmodel parameter for specific asrapi."); ?></span>
		</div>
	</div>
</div>
<!--END Model -->

<!-- credential key for Google API -->
<div class="credential_key_zone">
<div class="section-title" data-for="credential_key_part" id="id_credential_key_part">
	<h3><i class="fa fa-minus"></i><?php echo _("Credential key") ?></h3>
</div>
<div class="section" data-id="credential_key_part">
	<input type="hidden" name="keyjson_update" id="idkeyjson_update" value="">
	<!-- Credit -->
	<div class="element-container">
		<div class="row">
			<div class="col-md-12">
				<div class="row">
					<div class="form-group">
						<div class="col-md-3">
							<label class="control-label" for="keyjson"><?php echo _("Key") ?></label>
							<i class="fa fa-question-circle fpbx-help-icon" data-for="keyjson"></i>
						</div>
						<div class="col-md-9 radioset">
							<textarea class="form-control autosize" id="keyjson" name="keyjson" rows="15" onchange="onKeyjsonChange()"><?php echo $keyjson ?></textarea>
						</div>
					</div>
				</div>
			</div>
		</div>
		<div class="row">
			<div class="col-md-12">
				<span id="keyjson-help" class="help-block fpbx-help-block"> <?php echo _("Google credentials-key."); ?></span>
			</div>
		</div>
	</div>
</div>
</div>

</div>

<script type="text/javascript">

	//FreePBX embed jquery : cool

	function actdeact_ggle_credkey(ggle_act) {

		if (ggle_act) {
			$(".credential_key_zone").show();
		}
		else {
			$(".credential_key_zone").hide();
		}
		
		//var tabcredkey = document.getElementById("id_voximalcfg_keyjson");
		/*
		var tabcredkey = document.getElementById("id_credential_key_part");
		if (ggle_act) {
			tabcredkey.style.display = '';
			//alert("ttsapi google => hide credkey");
		}
		else {
			tabcredkey.style.display = 'none';
			//alert("ttsapi google => show credkey");
		}
		*/
	}

	// Handler on textarea Keyjson onChange()
	function onKeyjsonChange() {
		//alert( "Handler for onKeyjsonChange()" );
		document.getElementById("idkeyjson_update").value = "updated";
	}
	
	//Load on document ready
	$( document ).ready(function() {
	  	// Handler for .ready() called.
		hiddenotused();

		// Check if google api is selected
		var selasrapi = document.getElementById("asrapi");
		var asrapi    = selasrapi.options[selasrapi.selectedIndex].value;	
		if (asrapi.search("google") != -1)
			actdeact_ggle_credkey(true);
		else
			actdeact_ggle_credkey(false);
		
	});

	
	//Changeing to ASTERISK
	$("#method_asterisk").change(function() {
	    if(this.checked) {
		//Enabling ASTERISK asrmethod, check asruri is rtsp
		var asruri= $('#asruri').val();
		if( asruri.substring(0,3) != 'rtsp') 
			$('#asruri').val('rtsp://localhost:554');
	    }
	});

	function onsetpostorget(){
		//Enabling GET or POST asrmethod, check asruri is http
		var asruri= $('#asruri').val();
		if( asruri.substr(0,3) != 'http')
			$('#asruri').val($('#workingASR').val());
	}

	//Changeing to POST or GET or from 
	$("#method_get").change(onsetpostorget);
	$("#method_post").change(onsetpostorget);

	function cleanextapi(){
		var params= [ "asrid", "asruser", "asrpassword", "asrmodel", "asrkey" ];
		jQuery.each( params, function( i, param ) {
		$('#'+param).val('');
		});
	}
	function cleangenapi(){
		/*var formats= ['wav','wav16','pcm','alaw','ulaw','raw','sln16','sln'];
		jQuery.each( formats, function( i, format ) {
			$('input:radio[name="format"][value="'+format+'"]').prop('checked',false);
		});
		$('input:radio[name="asrmethod"][value="POST"]').prop('checked',false);
		$('input:radio[name="asrmethod"][value="GET"]').prop('checked',false);
		$('input:radio[name="asrmethod"][value="ASTERISK"]').prop('checked',false);
		$('#asruri').val('');*/
	}

	//Handler on asrapi combo change
	function onApiChangeAsr() {
		//alert( "Handler for change() called config" );
		//Cleaning unsed params, for a simpler conf file
		var selectapi = document.getElementById("asrapi");
		var asrapi    = selectapi.options[selectapi.selectedIndex].value;	
	
		switch(asrapi){
			case "voxygen":
			case "microsoft":
			case "cereproc":
			case "watson":
			case "google":
			case "google_streaming":
			case "google_dialogflow":
				//cleangenapi();
				break;
			case 'voximal':
				//cleanextapi();
				//cleangenapi();
				break;
			default:
				//set default woring HTTP ASR
				var asruri    = document.getElementById("asruri");
				var wrkasr    = document.getElementById("workingASR");
				var asrformat = document.getElementById("asrformat_wav16");
				var asrmethod = document.getElementById("asrmethod_post");
				
				asruri.value      = wrkasr.value;
				asrformat.checked = true;
				asrmethod.checked = true;
				//cleanextapi();
				break;
		}
		hiddenotused();
		
		var selttsapi = document.getElementById("ttsapi");
		var ttsapi    = selttsapi.options[selttsapi.selectedIndex].value;	
		//alert("tts=".ttsapi."/asr=".asrapi);
		if ((asrapi.search("google") != -1)  || (ttsapi == "google")) 
			actdeact_ggle_credkey(true);
		else
			actdeact_ggle_credkey(false);
		
	}
	
	//Just hide or show accordinf to asrapi value
	function hiddenotused(){
		var selectapi = document.getElementById("asrapi");
		var asrapi = selectapi.options[selectapi.selectedIndex].value;	
		switch(asrapi){
			case "voxygen":
			case "microsoft":
			case "cereproc":
			case "google":
				document.getElementById("eltcont_asrkey").style.display = '';
				document.getElementById("eltcont_asruser").style.display = 'none';
				document.getElementById("eltcont_asrpassword").style.display = 'none';
				document.getElementById("eltcont_asrmodel").style.display = 'none';
				document.getElementById("eltcont_asrid").style.display = 'none';
				document.getElementById("eltcont_asrmethod").style.display = 'none';
				break;
			case "google_streaming":
			case "google_dialogflow":
				document.getElementById("eltcont_asrkey").style.display = 'none';
				document.getElementById("eltcont_asruser").style.display = 'none';
				document.getElementById("eltcont_asrpassword").style.display = 'none';
				document.getElementById("eltcont_asrmodel").style.display = 'none';
				document.getElementById("eltcont_asrid").style.display = 'none';
				document.getElementById("eltcont_asrmethod").style.display = 'none';
				break;
			case "watson":
				document.getElementById("eltcont_asrkey").style.display = 'none';
				document.getElementById("eltcont_asruser").style.display = '';
				document.getElementById("eltcont_asrpassword").style.display = '';
				document.getElementById("eltcont_asrmodel").style.display = '';
				document.getElementById("eltcont_asrid").style.display = 'none';
				document.getElementById("eltcont_asrmethod").style.display = 'none';
				break;
			case "voximal":
      	document.getElementById("eltcont_asrkey").style.display = 'none';
				document.getElementById("eltcont_asruser").style.display = 'none';
				document.getElementById("eltcont_asrpassword").style.display = 'none';
				document.getElementById("eltcont_asrmodel").style.display = 'none';
				document.getElementById("eltcont_asrid").style.display = 'none';
				document.getElementById("eltcont_asrmethod").style.display = 'none';
				break;
			case "asterisk":
      	document.getElementById("eltcont_asrkey").style.display = 'none';
				document.getElementById("eltcont_asruser").style.display = 'none';
				document.getElementById("eltcont_asrpassword").style.display = 'none';
				document.getElementById("eltcont_asrmodel").style.display = 'none';
				document.getElementById("eltcont_asrid").style.display = 'none';
				document.getElementById("eltcont_asrmethod").style.display = 'none';
				break;
			default:
				//http or mrcp
				document.getElementById("eltcont_asrkey").style.display = '';
				document.getElementById("eltcont_asruser").style.display = '';
				document.getElementById("eltcont_asrpassword").style.display = '';
				document.getElementById("eltcont_asrmodel").style.display = '';
				document.getElementById("eltcont_asrid").style.display = '';
				document.getElementById("eltcont_asrmethod").style.display = '';
		}
	}

	function save() {

		var form = document.getElementById("settings");

		if (true) {
			form.submit();
		}

	}

	function isInt(n) {
		return n % 1 === 0;
	}
</script>

<?php?>
