<?php
//	License for all code of this FreePBX module can be found in the license file inside the module directory
//	Copyright 2015 Sangoma Technologies.
//


$filename           = $request['filename'];
$pathfile           = FreePBX::Voximal()->getDefaultAppPath();
$displayed_filename = "";

if (isset($request['filepath'])) {
	$pathfile = FreePBX::Voximal()->getBaseAllowedPath($request['filepath']);
  $pathfile .= "/";
}

if (isset($request['folder'])) {
	if (isset($request['root']) && ($request['root'] != "root")) {
		$pathfile .= $request['root'] . "/";
		$displayed_filename = $request['root'] . "/";		
	}
	$pathfile .= $request['folder'] . "/";
	$displayed_filename = $request['folder'] . "/";		
}
/*if (!empty($request['path']) && ($request['path'] != "root")) {
	$pathfile .= $request['path'] . "/";
	$displayed_filename = $request['path'] . "/";
}*/
$pathfile           .= $filename;
$displayed_filename .= $filename;

//echo "FILENAME " . $pathfile; 

freepbx_log(FPBX_LOG_CRITICAL,"==== DBGJYG: fileeditor: file=".$request['filename'] . " path=$pathfile");


	$exten = substr( $filename, strpos($filename,".") + 1);
	switch($exten) {
		case "sh":
			$mode = "shell";
			break;
		case "xml":
			$mode = "xml";
			break;
		case "vxml":
			$mode = "xml";
			break;
		case "aiml":
			$mode = "xml";
			break;
		case "grxml":
			$mode = "xml";
			break;
		case "gram":
			$mode = "xml";
			break;
		case "srgs":
			$mode = "xml";
			break;
		case "js":
			$mode = "javascript";
			break;
		case "php":
			$mode = "application/x-httpd-php";
			break;
		case "tpl":
			$mode = "xml";
			break;
		case "bak":
			$mode = "xml";
			break;
		default:
			$mode = $exten;
			break;
	}

?>
<script type="text/javascript" src="modules/voximal/assets/fileeditor.js"></script>

<script type="text/javascript">
	$(function() {
		var link = document.createElement( "link" );
		link.href = "modules/voximal/assets/codemirror/lib/codemirror.css";
		link.type = "text/css";
		link.rel = "stylesheet";
		link.media = "screen,print";
		document.getElementsByTagName( "head" )[0].appendChild( link );
		var link2 = document.createElement( "link" );
		link2.href = "modules/voximal/assets/codemirror/addon/hint/show-hint.css";
		link2.type = "text/css";
		link2.rel = "stylesheet";
		link2.media = "screen,print";
		document.getElementsByTagName( "head" )[0].appendChild( link2 );
	});
</script>
<script src="modules/voximal/assets/codemirror/lib/codemirror.js"></script>
<script src="modules/voximal/assets/codemirror/mode/xml/xml.js"></script>
<script src="modules/voximal/assets/codemirror/addon/hint/show-hint.js"></script>
<?php /*<script src="modules/voximal/assets/codemirror/addon/hint/anyword-hint.js"></script>*/ ?>
<script src="modules/voximal/assets/codemirror/addon/selection/active-line.js"></script>
<script src="modules/voximal/assets/codemirror/addon/edit/closebrackets.js"></script>
<script src="modules/voximal/assets/codemirror/addon/edit/closetag.js"></script>
<script src="modules/voximal/assets/codemirror/addon/fold/xml-fold.js"></script>
<script src="modules/voximal/assets/codemirror/addon/edit/matchtags.js"></script>
<?php if ($mode == "application/x-httpd-php") {?>
<script src="modules/voximal/assets/codemirror/mode/php/php.js"></script>
<script src="modules/voximal/assets/codemirror/mode/css/css.js"></script>
<script src="modules/voximal/assets/codemirror/mode/htmlmixed/htmlmixed.js"></script>
<script src="modules/voximal/assets/codemirror/mode/javascript/javascript.js"></script>
<script src="modules/vxml/assets/codemirror/mode/javascript/javascript.js"></script>
<script src="modules/vxml/assets/codemirror/mode/clike/clike.js"></script>
<?php } elseif ($mode == "javascript") {?>
<script src="modules/voximal/assets/codemirror/mode/javascript/javascript.js"></script>
<?php }?>


<div class="section" data-id="directoryandupload">
 	<!-- <form method="POST" action="?display=filemanager" id="idwizform"> -->
	<form class="fpbx-submit" id="filemanager" name="filemanager" method="post"  >
		<input type="hidden" name="action"   value="save">
		<input type="hidden" name="filename" value="<?php echo $request['filename']; ?>">
		<?php if (isset($request['folder'])) { ?>
		<input type="hidden" name="folder"     value="<?php echo $request['folder']; ?>"/>
		<?php } ?>
		<?php if (isset($request['root'])) { ?>
		<input type="hidden" name="root"     value="<?php echo $request['root']; ?>"/>
		<?php } ?>
		<?php if (isset($request['filepath'])) { ?>
		<input type="hidden" name="filepath"     value="<?php echo $request['filepath']; ?>"/>
		<?php } ?>
		<!-- <input type="hidden" name="root"     value="<?php echo $request['path']; ?>"/>		-->
		<!-- <input type="hidden" name="folder"   value="<?php echo $request['path']; ?>"/>			-->				
		<h2><input type="text" name="filename" value="<?php echo $displayed_filename ?>"></h2>
		
		<!-- 	<textarea class="form-control autosize" id="contentfile" name="contentfile" rows="15" > --> 
		<textarea id="code" name="code"  ><?php
				if (file_exists($pathfile)) {
					$f = fopen($pathfile,'r');
					while(!feof($f)) {
						$line = fgets($f);
						if (strpos($line,"<?xml") !== false) $line = ltrim($line);
						echo htmlspecialchars($line, ENT_XML1, 'UTF-8', true);
					}
					fclose($f);
				}
		?></textarea>
	</form>
</div>
<p id="idCheckResult"></p>

<style type="text/css">

	.myButtons {
		width: 70px;
	}

    .CodeMirror {
    	border: 1px solid #eee;
      	margin-left: 0;
    }

    .CodeMirror-sizer {
    	margin-left: 0;
    	width: 80%;
    }
</style>
<script type="text/javascript">

$('#body-content').on('change keyup keydown', 'input, textarea, select', function (e) {
    $(this).addClass('changed-input');
});

// $(window).on('beforeunload', function () {         Function to have "Leave site" popup before unload
//     if ($('.changed-input').length) {
//         return 'You haven\'t saved your changes.';
//     }
// });

$("#cancel").click(function(e){
	alert("Cancel handle click");
});
$("#checkvxml").click(function(e){
	alert("Check handle click");
});

function cancelClickHandler() {
	location.href="?display=voximalfilemanager";
}


function checkVxmlClickHandler() {
	//alert("checkVxmlClickHandler handle click");
	var codevxml = editor.getValue();

	//alert("Code:"+codevxml);
	var resHtml  = document.getElementById("idCheckResult");
	
	console.log("ajax.php?module=voximal&command=checkvxml...");
	$.post("ajax.php?module=voximal&command=checkvxml",
		{
		code: codevxml,
	}).done(function( data ) {
		console.log("ret form ajax checkvxml:"+data.status+" " +data.result);
		//resHtml.innerHTML = "ret form ajax checkvxml:"+data.status+" " +data.result;
		//resHtml.innerHTML = data.result;
		if ( data.status ) {
			resHtml.innerHTML = "";
			fpbxToast(data.result, '', 'success');
		} else {
			resHtml.innerHTML = data.result;
			fpbxToast(data.result, '', 'error');
		}
	}).fail(function( data ) {
		console.log("FAIL from ajax checkvxml");		
		resHtml.innerHTML = "Failed to check Vxml syntax";
		fpbxToast('Failed to check Vxml syntax', '', 'error');
	}).always(function() {
		console.log("ret form ajax checkvxml : always");
	});

} 	



/*
function enableBeforeUnload() {
	console.log("FUNCION enableBeforeUnload");
	window.onbeforeunload = function (e) {
		return "UNSAVED CHANGES!";
	};
}*/

function disableBeforeUnload() {
	window.onbeforeunload = null;
}

CodeMirror.commands.autocomplete = function(cm) {
	cm.showHint({hint: CodeMirror.hint.anyword});
}


var editor = CodeMirror.fromTextArea(document.getElementById("code"), {

    mode: "<?php echo $mode?>",
    styleActiveLine: true,
    lineNumbers: true,
    lineWrapping: true,
    autoCloseBrackets: true,
    autoCloseTags: true,
    matchTags: {bothTags: true},
    indentUnit: 4,
    indentWithTabs: true,
    enterMode: "keep",
    tabMode: "shift",
    extraKeys: {
      "Ctrl-Space": "autocomplete"
    }
});

editor.on("update", function() {
	$(".CodeMirror-gutter.CodeMirror-linenumbers").css("width","29px");
	$(".CodeMirror-gutter-wrapper").css("left","-30px");
	$(".CodeMirror-gutter-wrapper").css("width","30px");
	$(".CodeMirror-linenumber.CodeMirror-gutter-elt").css("width","21px");
	$(".CodeMirror-linenumber.CodeMirror-gutter-elt").css("left","0px");
});

$(".CodeMirror-hscrollbar").css("left","0");
$(".CodeMirror-sizer").css("margin-left","30px");
$(".CodeMirror-gutter.CodeMirror-linenumbers").css("width","29px");
$(".CodeMirror-gutter-wrapper").css("left","-30px");
$(".CodeMirror-gutter-wrapper").css("width","30px");
$(".CodeMirror-linenumber.CodeMirror-gutter-elt").css("width","21px");
$(".CodeMirror-linenumber.CodeMirror-gutter-elt").css("left","0px");




// $(document).ready(
// 		setTimeout(function(){
// 			editor.on("update",function() {
// 				console.log("FUNCION enableBeforeUnload");
// 				window.onbeforeunload = function (e) {
// 					return "UNSAVED CHANGES!";
// 				};
// 			});
// 		}, 1000)
// );

editor.setSize("100%","400px");

</script>
