<?php
// File    : general.voximalsettings.php
// Version : $Revision: 1.20 $




// Get Voximal license
global $astman;
if ($astman) {
	$out = $astman->send_request('Command',array('Command'=>"voximal show license"));
	$out = explode("\n",$out['data']);

    foreach ($out as $line) {
        if (strpos($line,":") !== false) {
            $value = explode(":", $line);
            if (count($value) == 1)
            $value[1]="";
            list($key, $val) = $value;
            $license_infos[rtrim(ltrim($key))] = trim(ltrim($val));
        }
    }
	$out = $astman->send_request('Command',array('Command'=>"voximal show version"));
	$out = explode("\n",$out['data']);
    foreach ($out as $line) {
        list($key, $val) = explode(":", $line);
        if (strcasecmp(rtrim(ltrim($key)), "Version") == 0) {
            $version_voximal = $val;
            break;
        }
    }
	$out = $astman->send_request('Command',array('Command'=>"voximal show license"));
	$out = explode("\n",$out['data']);
    foreach ($out as $line) {
        list($key, $val) = explode(":", $line);
        if (strcasecmp(rtrim(ltrim($key)), "PIN") == 0) {
            $PIN_voximal = $val;
            break;
        }
    }
}

// GEt voximal configuration
//$settings = getVoximalConfiguration('*');
$settings = getGeneralConf(true);
//echo "<br>getGeneralConf<br>";
//print_r($settings);

// Set voximal debug levelif (trim($settings['debug']) == "yes") {
$debug_no = false;
if ( (trim($settings['debug']) != "interpreter") && (trim($settings['debug']) != "yes")) {
	$debug_no = true;
}

?>
<div id="voximalcfg_general" class="tab-pane active">
<input type="hidden" name="action" value="save">
<!--Version-->
<div class="element-container">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="voxiversion"><?php echo _("Version") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="voxiversion"></i>
					</div>
					<div class="col-md-9">
						<?php echo isset($version_voximal)?$version_voximal:'444'; ?>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="voxiversion-help" class="help-block fpbx-help-block">You can easly make tests by calling your Voxibot :
				Call the <a href='tel:0033972538823'>+33(0)972538823</a> and enter the followed PIN number.
			</span>
		</div>
	</div>
</div>
<!-- END Version -->
<!-- PIN -->
<div class="element-container">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="voxipin"><?php echo _("PIN") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="voxipin"></i>
					</div>
					<div class="col-md-9">
						<?php echo isset($PIN_voximal)?$PIN_voximal:'444'; ?>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
<!-- END PIN -->
<!-- Dial format -->
<div class="element-container">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="dialformat"><?php echo _("Dial format") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="dialformat"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="text" class="form-control" id="dialformat" name="dialformat" value="<?php echo isset($settings['dialformat'])?$settings['dialformat']:'SIP/%s'?>">
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="dialformat-help" class="help-block fpbx-help-block"> <?php echo _("Dial expression format for the transfers."); ?></span>
		</div>
	</div>
</div>
<!--END Dialformat-->
<!-- Blind application -->
<div class="element-container">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="blindapplication"><?php echo _("Blind application") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="blindapplication"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="text" class="form-control" id="blindapplication" name="blindapplication" value="<?php echo isset($settings['blindapplication']) ? $settings['blindapplication'] : ''?>">
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="blindapplication-help" class="help-block fpbx-help-block"> <?php echo _("Application to use for the blind transfers."); ?></span>
		</div>
	</div>
</div>
<!--END Blind application -->
<!-- Record silence -->
<div class="element-container">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="recordsilence"><?php echo _("Record silence") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="recordsilence"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="radio" name="recordsilence" id="recordsilenceyes" value="yes" <?php echo (trim($settings['recordsilence']) == "yes"?"CHECKED":"") ?>>
						<label for="recordsilenceyes"><?php echo _("Yes");?></label>
						<input type="radio" name="recordsilence" id="recordsilenceno" value="no" <?php echo (trim($settings['recordsilence']) == "yes"?"":"CHECKED") ?>>
						<label for="recordsilenceno"><?php echo _("No");?></label>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="recordsilence-help" class="help-block fpbx-help-block"><?php echo _("Save silence stream in record file.")?></span>
		</div>
	</div>
</div>
<!--END Record silence-->
<!-- Threshold -->
<div class="element-container">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="threshold"><?php echo _("Threshold") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="threshold"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="number" class="form-control" id="threshold" name="threshold" value="<?php echo trim($settings['threshold'])?>">
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="threshold-help" class="help-block fpbx-help-block"> <?php echo _("Sensibility level for record/speech."); ?></span>
		</div>
	</div>
</div>
<!-- END Threshold -->
<!-- WAV default codec -->
<div class="element-container">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="wavdefaultcodec"><?php echo _("WAV default codec") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="wavdefaultcodec"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="radio" name="wavdefaultcodec" id="defaultcodecpcm" value="pcm" <?php echo (trim($settings['wavdefaultcodec']) != "gsm"?"CHECKED":"") ?>>
						<label for="defaultcodecpcm"><?php echo _("pcm");?></label>
						<input type="radio" name="wavdefaultcodec" id="defaultcodecgsm" value="gsm" <?php echo (trim($settings['wavdefaultcodec']) == "gsm"?"CHECKED":"") ?>>
						<label for="defaultcodecgsm"><?php echo _("gsm");?></label>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="wavdefaultcodec-help" class="help-block fpbx-help-block"><?php echo _("Codec type to use for record.")?></span>
		</div>
	</div>
</div>
<!--END WAV default codec-->
<!-- Speech beeps -->
<div class="element-container">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="speechbeeps"><?php echo _("Speech beeps") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="speechbeeps"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="radio" name="speechbeeps" id="speechbeepsyes" value="yes" <?php echo (trim($settings['speechbeeps']) == "yes"?"CHECKED":"") ?>>
						<label for="speechbeepsyes"><?php echo _("Yes");?></label>
						<input type="radio" name="speechbeeps" id="speechbeepsno" value="no" <?php echo (trim($settings['speechbeeps']) == "yes"?"":"CHECKED") ?>>
						<label for="speechbeepsno"><?php echo _("No");?></label>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="speechbeeps-help" class="help-block fpbx-help-block"><?php echo _("Play start and stop beeps to mark the speech recognition.")?></span>
		</div>
	</div>
</div>
<!--END Speech beeps-->
<!-- debug -->
<div class="element-container">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="debug"><?php echo _("Debug") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="debug"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="radio" name="debug" id="debugyes" value="yes" <?php echo (trim($settings['debug']) == "yes"?"CHECKED":"") ?>>
						<label for="debugyes"><?php echo _("Yes");?></label>
						<input type="radio" name="debug" id="debugno" value="no" <?php echo ($debug_no == true?"CHECKED":"") ?>>
						<label for="debugno"><?php echo _("No");?></label>
						<input type="radio" name="debug" id="debuginterp" value="interpreter" <?php echo (trim($settings['debug']) == "interpreter"?"CHECKED":"") ?>>
						<label for="debuginterp"><?php echo _("Interpreter");?></label>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="debug-help" class="help-block fpbx-help-block"><?php echo _("Voximal logs level.")?></span>
		</div>
	</div>
</div>
<!--END debug-->
<!-- Monitoring -->
<div class="element-container">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="monitor"><?php echo _("Monitoring") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="monitor"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="radio" name="monitor" id="monitoryes" value="yes" <?php echo (trim($settings['monitor']) == "yes"?"CHECKED":"") ?>>
						<label for="monitoryes"><?php echo _("Yes");?></label>
						<input type="radio" name="monitor" id="monitorno" value="no" <?php echo (trim($settings['monitor']) == "yes"?"":"CHECKED") ?>>
						<label for="monitorno"><?php echo _("No");?></label>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="monitor-help" class="help-block fpbx-help-block"><?php echo _("Record call (bidirectionnal stream).<br><br><b><u>Warning:</u> If you active this option, you need to inform user that his call is recorded!</b>")?></span>
		</div>
	</div>
</div>
<!--END Monitoring-->
<!-- Priority events -->
<div class="element-container">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="priorityevents"><?php echo _("Priority events") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="priorityevents"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="radio" name="priorityevents" id="priorityeventsyes" value="yes" <?php echo (trim($settings['priorityevents']) == "yes"?"CHECKED":"") ?>>
						<label for="priorityeventsyes"><?php echo _("Yes");?></label>
						<input type="radio" name="priorityevents" id="priorityeventsno" value="no" <?php echo (trim($settings['priorityevents']) == "yes"?"":"CHECKED") ?>>
						<label for="priorityeventsno"><?php echo _("No");?></label>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="priorityevents-help" class="help-block fpbx-help-block"><?php echo _("Record call (bidirectionnal stream).<br><br><b><u>Warning:</u> If you active this option, you need to inform user that his call is recorded!</b>")?></span>
		</div>
	</div>
</div>
<!--END Priority events-->
<!-- Cache timeout(s) -->
<div class="element-container">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="cachetimeout"><?php echo _("Cache timeout(s)") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="cachetimeout"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="number" class="form-control" id="cachetimeout" name="cachetimeout" value="<?php echo isset($settings['cachetimeout']) ? $settings['cachetimeout'] : '60'?>">
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="cachetimeout-help" class="help-block fpbx-help-block"> <?php echo _("Define cache size in second."); ?></span>
		</div>
	</div>
</div>
<!-- END Cache timeout(s) -->

</div>
