<?php
// File    : license.voximalsettings.php
// Version : $Revision: 1.15 $


global $astman;

$license = getVoximalLicense();
if ($astman) {
	$out = $astman->send_request('Command',array('Command'=>"voximal show license"));
	$out = explode("\n",$out['data']);

    foreach ($out as $line) {
        if (strpos($line,":") !== false) {
            $value = explode(":", $line);
            if (count($value) == 1)
            $value[1]="";
            list($key, $val) = $value;
            $val = trim(ltrim($val));
            if (isset($val) && $val != "")
            $license_infos[rtrim(ltrim($key))] = trim(ltrim($val));
        }
    }

    //print_r ($license_infos);
}

//print_r ($license);


if ($license == '') {
    $license_mng    = "Remote";
    $remote_checked = "checked";
    $local_checked  = "";
    $dispRemoteLic  = "table-row";
    $dispLocalLic   = "none";
}
else {
    $license_mng = "Local";
    $remote_checked = "";
    $local_checked  = "checked";
    $dispRemoteLic  = "none";
    $dispLocalLic   = ""; // "table-row";
}


$licExpired        = false;
$licWithExpiration = false;
// Check expiration date
if (isset($license_infos["Expiration"])) {
    $elts       = explode(" ", $license_infos["Expiration"]);
    $expdate    = $elts[0];
    $now        = new DateTime(date("Y-m-d")); //date('Y-m-d'));
    $expiration = new DateTime($expdate); //$elt["last_req"]);
    $interval   = $now->diff($expiration);
     // pour avoir le nb de jours de diff avec signe : $interval->format('%R%a')
    $nbDayDiff = $interval->format('%R%a');
   //echo("$expdate => $nbDayDiff" );
    if ($nbDayDiff <= 0)
        $licExpired = true;
    else
        $licWithExpiration = true;
}



$help_lic_mng_status  = _("License manager status :<br><ul><li>Ok : The connection with license server is OK</li></ul>");

$tabindex = 0;
?>

<div id="voximalcfg_lic" class="tab-pane">
<input type="hidden" name="action" value="save">
<!--UID-->
<div class="element-container">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="licenceuid"><?php echo _("UID") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="licenceuid"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="text" class="form-control" id="licenceuid" name="licenceuid" value="<?php echo $license_infos["UID"]?>">
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="licenceuid-help" class="help-block fpbx-help-block"> <?php echo _("Key identification for IVR."); ?></span>
		</div>
	</div>
</div>
<!-- END UID -->
<!-- License -->
<div class="element-container">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="license"><?php echo _("License") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="license"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="radio" name="license" id="licenseremote" value="remote" <?php echo $remote_checked ?> onchange="licRemoteOnchange()" >
						<label for="licenseremote"><?php echo _("Remote");?></label>
						<input type="radio" name="license" id="licenselocal" value="local" <?php echo $local_checked ?> onchange="licLocalOnchange()" >
						<label for="licenselocal"><?php echo _("Local");?></label>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="license-help" class="help-block fpbx-help-block"><?php echo _("Play start and stop beeps to mark the speech recognition.")?></span>
		</div>
	</div>
</div>
<!--END License-->
<!-- Max sessions -->
<div class="element-container">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="maxsessions"><?php echo _("Max sessions") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="maxsessions"></i>
					</div>
					<div class="col-md-9 radioset">
						<?php echo $license_infos["Max sessions"] ?>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="maxsessions-help" class="help-block fpbx-help-block"><?php echo _("Maximum simultaneous calls.")?></span>
		</div>
	</div>
</div>
<!--END Max sessions-->
<!-- TTS -->
<div class="element-container">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="tts"><?php echo _("TTS") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="tts"></i>
					</div>
					<div class="col-md-9 radioset">
						<?php echo (!strcasecmp($license_infos["TextToSpeech"],"Yes"))?"Enable":"Disable"; ?>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="tts-help" class="help-block fpbx-help-block"><?php echo _("Text To Speech module status.")?></span>
		</div>
	</div>
</div>
<!--END TTS-->
<!-- ASR -->
<div class="element-container">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="asr"><?php echo _("ASR") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="asr"></i>
					</div>
					<div class="col-md-9 radioset">
						<?php echo (!strcasecmp($license_infos["Speech"],"Yes"))?"Enable":"Disable"; ?>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="asr-help" class="help-block fpbx-help-block"><?php echo _("Voice recognition module status.")?></span>
		</div>
	</div>
</div>
<!--END ASR-->
<!-- License status -->
<div class="element-container" id="idlicencestatus">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="licensestatus"><?php echo _("License status") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="licensestatus"></i>
					</div>
					<div class="col-md-9 radioset">
						<?php if ($licExpired) {
									echo _("Expired");
								}
								else if ($licWithExpiration){
									echo _("Expiration");
								}
								else {
									echo $license_infos["State"];
								} ?>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="licensestatus-help" class="help-block fpbx-help-block"><?php echo $help_lic_mng_status;?></span>
		</div>
	</div>
</div>
<!--END License status-->

<!-- License code -->
<div class="element-container" id="idlicencecode" style="display: <?php echo $dispLocalLic?>">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="licensecode"><?php echo _("Code") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="licensecode"></i>
					</div>
					<div class="col-md-9 radioset">
						<?php echo $license_infos["Code"]; ?>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="licensecode-help" class="help-block fpbx-help-block"><?php echo _("This code is used to generate your local license key. Give it to support with UID to get your license key.");?></span>
		</div>
	</div>
</div>
<!--END License code-->
<!-- License key -->
<div class="element-container" id="idlicencekey" style="display: <?php echo $dispLocalLic?>">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="licensekey"><?php echo _("Key") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="licensekey"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="text" class="form-control" id="licensekey" name="licensekey" value="<?php echo $license ;/*$license_infos["licensekey"]*/?>">
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="licensekey-help" class="help-block fpbx-help-block"><?php echo _("Enter the key value for your license.");?></span>
		</div>
	</div>
</div>
</div>

<script type="text/javascript">

	function licRemoteOnchange() {

		var lic_remote = document.getElementById("licenseremote");
        var lic_local  = document.getElementById("licenselocal");

        if (lic_remote.checked) {
            var answer = confirm ("<?php echo _("Are you sure to switch to REMOTE license")?> ?");
            if (!answer) {
                lic_remote.checked = false;
                lic_local.checked = true;
            }
            else {
				document.getElementById("idlicencestatus").style.display = "";
				document.getElementById("idlicencekey").style.display    = "none";
				document.getElementById("idlicencecode").style.display   = "none";
            }
        }
	}
	function licLocalOnchange() {

		var lic_remote = document.getElementById("licenseremote");
        var lic_local  = document.getElementById("licenselocal");


        if (lic_remote.checked)
            alert("licLocalOnchange: remote cheched");

        if (lic_local.checked) {
            var answer = confirm ("<?php echo _("Are you sure to switch to LOCAL license")?> ?");
            if (!answer) {
                lic_local.checked = false;
                lic_remote.checked = true;
            }
            else {
				document.getElementById("idlicencestatus").style.display = "none";
				document.getElementById("idlicencekey").style.display    = "";
				document.getElementById("idlicencecode").style.display   = "";
            }
        }
	}





</script>
