<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed'); }

$getvars = array(
	'action'		=> '',
	'dateformat'	=> '',
	'display' 		=> '',
	'appendhostname'=> '',
	'logfile'		=> '',
	'logfiles'		=> '',
	'lines'			=> '',
	'queue_log'		=> '',
	'rotatestrategy'=> '',
	'view'			=> '',
	'filter' => false
);

foreach ($getvars as $k => $v) {
	$var[$k]	= isset($_REQUEST[$k]) ? $_REQUEST[$k] : $v;
}

//sanitize input
$var['lines'] = preg_replace("/[^0-9]/", "", $var['lines']);
$var['logfile'] = preg_replace("/[^0-9]/", "", $var['logfile']);
//echo logfiles_rnav();


//respond to ajax requests
if ($var['lines']) {
	while (ob_get_level()) {
		ob_end_clean();
	}
	echo get_logfile($var['lines'], $var['logfile'],$var['filter']);
	exit();

}

switch ($var['action']) {
	case 'save':
		//put_opts($var);
		break;
}


/**
 * Get list of files
 */
function voxilogfiles_list() {
	$list = array("/var/log/voximal/vxml.log", 
                  "/var/log/voximal/debug.log");
	return $list;
}



/**
 * Get last X lines of log file, with html tags to provide highlighting
 */
function get_logfile($lines = 500, $file, $filter=false) {
//	global $amp_conf;
	$files   = voxilogfiles_list();
	$logfile = $files[$file];

	if (!file_exists($logfile) || !is_file($logfile)) {
		echo _('Error parsing log file or file not found! ').$logfile;
		return;
	}

	$channels = array();
	exec(fpbx_which('tail') . ' -n' . $lines . ' ' . $logfile, $log);
	if($filter){
		$regex_check = @preg_match('/'.$filter.'/', null);
		if($regex_check !== 0){
				echo _("Invalid pattern");
				return;
		}else{
				$log = preg_grep('/'.$filter.'/', $log);
		}
	}
	//If we filter out all the things....
	if(empty($log)){
		echo _("No lines returned");
		return;
	}
	foreach($log as $l){
		switch (true) {
		case strpos($l, 'INFO'):
			$l = '<span class="beige">' . htmlentities($l,ENT_COMPAT | ENT_HTML401, "UTF-8") . '</span>';
			break;
		case strpos($l, 'WARNING'):
			$l = '<span class="orange">' . htmlentities($l,ENT_COMPAT | ENT_HTML401, "UTF-8") . '</span>';
			break;
		case strpos($l, 'DEBUG'):
			$l = '<span class="green">' . htmlentities($l,ENT_COMPAT | ENT_HTML401, "UTF-8") . '</span>';
			break;
		case strpos($l, 'UPDATE'):
		case strpos($l, 'NOTICE'):
			$l = '<span class="cyan">' . htmlentities($l,ENT_COMPAT | ENT_HTML401, "UTF-8") . '</span>';
			break;
		case strpos($l, 'FATAL'):
		case strpos($l, 'CRITICAL'):
		case strpos($l, 'ERROR'):
			$l = '<span class="red">' . htmlentities($l,ENT_COMPAT | ENT_HTML401, "UTF-8") . '</span>';
			break;
		default:
			$l = highlight(htmlentities($l, ENT_NOQUOTES,"UTF-8"),$channels);
			break;
		}
		echo $l . '<br />';
	}
}

/*
 * Highlight asterisk applications
 */
function highlight($line,&$channels) {
	//for i in `asterisk -rx 'core show applications'|awk '{print $1}'|grep -v -|sed 's/://g'`; do echo -n $i'|'; done
	static $apps = 'AddQueueMember|ADSIProg|AELSub|AGI|Answer|Authenticate|BackGround|BackgroundDetect|Bridge|Busy|CallCompletionCancel|CallCompletionRequest|CELGenUserEvent|ChangeMonitor|ChanIsAvail|ChannelRedirect|ChanSpy|ClearHash|ConfBridge|Congestion|ContinueWhile|ControlPlayback|DAHDIAcceptR2Call|DAHDIBarge|DAHDIRAS|DAHDIScan|DAHDISendKeypadFacility|DateTime|DBdel|DBdeltree|DeadAGI|Dial|Dictate|Directory|DISA|DumpChan|EAGI|Echo|EndWhile|Exec|ExecIf|ExecIfTime|ExitWhile|ExtenSpy|ExternalIVR|Flash|Flite|ForkCDR|GetCPEID|Gosub|GosubIf|Goto|GotoIf|GotoIfTime|Hangup|IAX2Provision|ICES|ImportVar|Incomplete|Log|Macro|MacroExclusive|MacroExit|MacroIf|MailboxExists|MeetMe|MeetMeAdmin|MeetMeChannelAdmin|MeetMeCount|Milliwatt|MinivmAccMess|MinivmDelete|MinivmGreet|MinivmMWI|MinivmNotify|MinivmRecord|MixMonitor|Monitor|Morsecode|MP3Player|MSet|MusicOnHold|MYSQL|NBScat|NoCDR|NoOp|Originate|Page|Park|ParkAndAnnounce|ParkedCall|PauseMonitor|PauseQueueMember|Pickup|PickupChan|Playback|PlayTones|PrivacyManager|Proceeding|Progress|Queue|QueueLog|RaiseException|Read|ReadExten|ReadFile|ReceiveFAX|Record|RemoveQueueMember|ResetCDR|RetryDial|Return|Ringing|SayAlpha|SayCountPL|SayDigits|SayNumber|SayPhonetic|SayUnixTime|SendDTMF|SendFAX|SendImage|SendText|SendURL|Set|SetAMAFlags|SetCallerPres|SetMusicOnHold|SIPAddHeader|SIPDtmfMode|SIPRemoveHeader|SLAStation|SLATrunk|SMS|SoftHangup|SpeechActivateGrammar|SpeechBackground|SpeechCreate|SpeechDeactivateGrammar|SpeechDestroy|SpeechLoadGrammar|SpeechProcessingSound|SpeechStart|SpeechUnloadGrammar|StackPop|StartMusicOnHold|StopMixMonitor|StopMonitor|StopMusicOnHold|StopPlayTones|System|TestClient|TestServer|Transfer|TryExec|TrySystem|UnpauseMonitor|UnpauseQueueMember|UserEvent|Verbose|VMAuthenticate|VMSayName|VoiceMail|VoiceMailMain|Wait|WaitExten|WaitForNoise|WaitForRing|WaitForSilence|WaitMusicOnHold|WaitUntil|While|Zapateller';

	//Match Channel ID
	$colors = array("silver","seagreen","lime","red","orange","green","yellow","magenta","pink");
	if(preg_match('/\[(\d*)\]/',$line,$matches)) {
		if(!isset($channels[$matches[1]])) {
			$channels[$matches[1]] = $colors[rand(0,count($colors)-1)];
		}
		$line = str_replace('['.$matches[1].']','[<span class="'.$channels[$matches[1]].'">'.$matches[1].'</span>]',$line);
	}

	//match any app
	$line = preg_replace('/(?:' . $apps . ')(?=\()/', '<span class="app">$0</span>', $line, 1);
	//match arguments
	$line = preg_replace('/(?<=\(\").*(?=\"\,)/', '<span class="appargs">$0</span>', $line, 1);
	$line = preg_replace('/(?<=\,( )\").*(?=\"\))/', '<span class="appargs">$0</span>', $line, 1);
	return $line;
}
