<?php
// File    : tts.voximalsettings.php
// Version : $Revision: 1.28 $


//init some global variables
$ccache_message="";
$ccache_color="";

//Bind with jaavscript this value
$workingTTS=getWorkingTTS();

if (isset($_POST['ccache']) ) {
	list($ccache_message,$ccache_color)=clearVoximalCache();
}



// GEt voximal configuration
$settings = getPromptConf(true);

//debug
/*
if(count($_POST))
echo "<pre>POST\n".print_r($_POST,true)."</pre>";
echo "<pre>Settings\n".print_r($settings,true)."</pre>";
 */

//Apis
$tts_apis=array(
	'HTTP (default)'=>'default',
	'Asterisk'=>'asterisk',
	'PicoTTS (free)'=>'pico',
	'Voximal Cloud'=>'voximal',
	'Voxygen Cloud'=>'voxygen',
	'Cereproc Cloud'=>'cereproc',
	'iSpeech Text to Speech'=>'ispeech',
	'Microsoft Bing Speech API'=>'microsoft',
	'IBM/Watson Text to Speech'=>'watson',
	'Amazon/Polly Text to Speech'=>'polly',
	'Google Text to Speech'=>'google',
	'Yandex Text to Speech'=>'yandex',
	);

//We check the value of Method
if (trim($settings['method']) == "ASTERISK") {
	$method_asterisk   = "checked";
	$method_post       = "";
	$method_get        = "";
}
else if (trim($settings['method']) == "GET") {
	$method_asterisk   = "";
	$method_post       = "";
	$method_get        = "checked";
}
else {
	$method_asterisk   = "";
	$method_post       = "checked";
	$method_get        = "";
}
//Add format changing only this array
$tts_formats=array('wav'=>'','wav16'=>'','pcm'=>'','alaw'=>'','ulaw'=>'','raw'=>'','sln'=>'','sln16'=>'');
foreach($tts_formats as $ttsf => $val){
	if (trim($settings['format']) == $ttsf){
		$tts_formats[$ttsf]='checked';
	}else{
		$tts_formats[$ttsf]='';
	}
}

//We check the value of SSML
if (trim($settings['ssml']) == 1) {
	$ssml_yes   = "checked";
	$ssml_no    = "";
}
else {
	$ssml_yes   = "";
	$ssml_no    = "checked";
}

//cutprompt
if (trim($settings['cutprompt']) == 1) {
	$cutprompt_yes   = "checked";
	$cutprompt_no    = "";
}
else {
	$cutprompt_yes   = "";
	$cutprompt_no    = "checked";
}


$tabindex = 0;


?>

<div id="voximalcfg_tts" class="tab-pane">
<input type="hidden" name="action" value="save">
<input type="hidden" id="workingTTS" name="workingTTS" value="<?php echo $workingTTS ?>">

<!--TTS API -->
<div class="element-container">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="ttsapi"><?php echo _("API") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="ttsapi"></i>
					</div>
						<div class="col-md-9">
							<select id="ttsapi" name="ttsapi" class="form-control" onchange="onApiChangeTts()" >
							<?php
								foreach ( $tts_apis as $ApiName=>$ApiCode ){ ?>
								<option value="<?php echo $ApiCode;?>" <?php echo $settings['api']== $ApiCode?"selected":""?>><?php echo $ApiName?></option>								
								
							<?php } ?>
							</select>
						</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="ttsapi-help" class="help-block fpbx-help-block"> <?php echo _("Text To Speech API to use."); ?></span>
		</div>
	</div>
</div>
<!-- TTS API  -->
<!-- URI -->
<div class="element-container" id="eltcont_uri">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="uri"><?php echo _("URI") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="uri"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="text" class="form-control" id="uri" name="uri" value="<?php echo isset($settings['uri'])?$settings['uri']:''?>">
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="uri-help" class="help-block fpbx-help-block"> <?php echo _("URI used."); ?></span>
		</div>
	</div>
</div>
<!--END URI-->
<!-- Method -->
<div class="element-container" id="eltcont_method">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="method"><?php echo _("Method") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="method"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="radio" name="method" id="method_post" value="POST" <?php echo $method_post ?>>
						<label for="method_post"><?php echo _("POST");?></label>
						<input type="radio" name="method" id="method_get" value="GET" <?php echo $method_get ?>>
						<label for="method_get"><?php echo _("GET");?></label>
						<input type="radio" name="method" id="method_asterisk" value="ASTERISK" <?php echo $method_asterisk ?>>
						<label for="method_asterisk"><?php echo _("ASTERISK");?></label>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="method-help" class="help-block fpbx-help-block"><?php echo _("HTTP method, or set Asterisk to send the text to the Asterisk module.")?></span>
		</div>
	</div>
</div>
<!--END Method -->
<!-- Format -->
<div class="element-container"  id="eltcont_format">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="format"><?php echo _("Format") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="format"></i>
					</div>
					<div class="col-md-9 radioset">
						<?php
						foreach($tts_formats as $ttsf => $checked){ ?>
						<input type="radio" name="format" id="format_<?php echo $ttsf?>" value="<?php echo $ttsf?>" <?php echo $checked?> tabindex="<?php echo $tabindex++?>">
						<label for="format_<?php echo $ttsf?>"><?php echo $ttsf?></label>
						<?php }?>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="format-help" class="help-block fpbx-help-block"><?php echo _("Format expected for audio files.")?></span>
		</div>
	</div>
</div>
<!--END Format -->
<!-- TTS ID -->
<div class="element-container"  id="eltcont_id">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="id"><?php echo _("ID") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="id"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="text" class="form-control" id="id" name="id" value="<?php echo isset($settings['id']) ? $settings['id'] : ''?>">
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="id-help" class="help-block fpbx-help-block"> <?php echo _("Define id parameter for specific ttsapi."); ?></span>
		</div>
	</div>
</div>
<!--END TTS ID -->
<!-- TTS KEY -->
<div class="element-container"  id="eltcont_key">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="key"><?php echo _("Key") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="key"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="text" class="form-control" id="key" name="key" value="<?php echo isset($settings['key']) ? $settings['key'] : ''?>">
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="key-help" class="help-block fpbx-help-block"> <?php echo _("Define key parameter for specific ttsapi."); ?></span>
		</div>
	</div>
</div>
<!--END TTS KEY -->
<!-- TTS USER -->
<div class="element-container"  id="eltcont_user">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="user"><?php echo _("User") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="user"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="text" class="form-control" id="user" name="user" value="<?php echo isset($settings['user']) ? $settings['user'] : ''?>">
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="user-help" class="help-block fpbx-help-block"> <?php echo _("Define User parameter for specific ttsapi."); ?></span>
		</div>
	</div>
</div>
<!--END TTS USER -->
<!-- TTS Password -->
<div class="element-container" id="eltcont_password" >
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="password"><?php echo _("Password") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="password"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="text" class="form-control" id="password" name="password" value="<?php echo isset($settings['password']) ? $settings['password'] : ''?>">
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="password-help" class="help-block fpbx-help-block"> <?php echo _("Define Password parameter for specific ttsapi."); ?></span>
		</div>
	</div>
</div>
<!--END TTS Password -->
<!-- TTS Voice -->
<div class="element-container"  id="eltcont_voice">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="voice"><?php echo _("Voice") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="voice"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="text" class="form-control" id="voice" name="voice" value="<?php echo isset($settings['voice']) ? $settings['voice'] : ''?>">
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="voice-help" class="help-block fpbx-help-block"> <?php echo _("Define Voice parameter for specific ttsapi."); ?></span>
		</div>
	</div>
</div>
<!--END TTS Voice -->
<!-- TTS Speed -->
<div class="element-container"  id="eltcont_speed">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="speed"><?php echo _("Speed") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="speed"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="text" class="form-control" id="speed" name="speed" value="<?php echo isset($settings['speed']) ? $settings['speed'] : ''?>">
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="speed-help" class="help-block fpbx-help-block"> <?php echo _("Define Speed parameter for specific ttsapi."); ?></span>
		</div>
	</div>
</div>
<!--END TTS Speed -->
<!-- SSML -->
<div class="element-container"  id="eltcont_ssml">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="ssml"><?php echo _("SSML") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="ssml"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="radio" name="ssml" id="ssmlyes" value="yes" <?php echo (trim($settings['ssml']) == "yes"?"CHECKED":"") ?>>
						<label for="ssmlyes"><?php echo _("Yes");?></label>
						<input type="radio" name="ssml" id="ssmlno" value="no" <?php echo (trim($settings['ssml']) == "yes"?"":"CHECKED") ?>>
						<label for="ssmlno"><?php echo _("No");?></label>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="ssml-help" class="help-block fpbx-help-block"><?php echo _("Enable or disbale SSML.")?></span>
		</div>
	</div>
</div>
<!--END SSML-->
<!-- Cache ageing -->
<div class="element-container"  id="eltcont_maxage">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="maxage"><?php echo _("Cache ageing") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="maxage"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="number" class="form-control" id="maxage" name="maxage" value="<?php echo isset($settings['maxage']) ? $settings['maxage'] : '0'?>">
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="maxage-help" class="help-block fpbx-help-block"> <?php echo _("Define cache maxage parameter in seconds, -1 means no expiry (by default) and 0 means that cache is disabled."); ?></span>
		</div>
	</div>
</div>
<!--END Cache ageing-->
<!-- Cut prompt -->
<div class="element-container"  id="eltcont_cutprompt">
	<div class="row">
		<div class="col-md-12">
			<div class="row">
				<div class="form-group">
					<div class="col-md-3">
						<label class="control-label" for="cutprompt"><?php echo _("Cut prompt") ?></label>
						<i class="fa fa-question-circle fpbx-help-icon" data-for="cutprompt"></i>
					</div>
					<div class="col-md-9 radioset">
						<input type="radio" name="cutprompt" id="cutpromptyes" value="yes" <?php echo (trim($settings['cutprompt']) == "yes"?"CHECKED":"") ?>>
						<label for="cutpromptyes"><?php echo _("Yes");?></label>
						<input type="radio" name="cutprompt" id="cutpromptno" value="no" <?php echo (trim($settings['cutprompt']) == "yes"?"":"CHECKED") ?>>
						<label for="cutpromptno"><?php echo _("No");?></label>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="col-md-12">
			<span id="cutprompt-help" class="help-block fpbx-help-block"><?php echo _("Define cache maxage parameter in seconds, -1 means no expiry (by default) and 0 means that cache is disabled.")?></span>
		</div>
	</div>
</div>
<!--END Cut prompt-->

</div>

<script type="text/javascript">

	//FreePBX embed jquery : cool

	//Load on document ready
	$( document ).ready(function() {
	  	// Handler for .ready() called.
		hiddenotused();
		
		// Check if google api is selected
		
		/*var selectapi = document.getElementById("ttsapi");
		var ttsapi    = selectapi.options[selectapi.selectedIndex].value;	
		if (ttsapi == "google") 
			actdeact_ggle_credkey(true);
		else
			actdeact_ggle_credkey(false);
		*/
	});

	
	//Changeing to ASTERISK
	$("#method_asterisk").change(function() {
	    if(this.checked) {
		//Enabling ASTERISK method, check uri is rtsp
		var uri= $('#uri').val();
		if( uri.substring(0,3) != 'rtsp') 
			$('#uri').val('rtsp://localhost:554');
	    }
	});

	function onsetpostorget(){
		//Enabling GET or POST method, check uri is http
		var uri= $('#uri').val();
		if( uri.substr(0,3) != 'http')
			$('#uri').val($('#workingTTS').val());
	}

	//Changeing to POST or GET or from 
	$("#method_get").change(onsetpostorget);
	$("#method_post").change(onsetpostorget);

	function cleanextapi(){
		var params= [ "id", "user", "password", "voice", "key", "speed"];
		jQuery.each( params, function( i, param ) {
		$('#'+param).val('');
		});
	}
	function cleangenapi(){
		/*var formats= ['wav','wav16','pcm','alaw','ulaw','raw','sln16','sln'];
		jQuery.each( formats, function( i, format ) {
			$('input:radio[name="format"][value="'+format+'"]').prop('checked',false);
		});
		$('input:radio[name="method"][value="POST"]').prop('checked',false);
		$('input:radio[name="method"][value="GET"]').prop('checked',false);
		$('input:radio[name="method"][value="ASTERISK"]').prop('checked',false);
		$('#uri').val('');*/
	}

				
	//Handler on ttsapi combo change
	function onApiChangeTts() {
		//alert( "Handler for change() called config" );
		//Cleaning unsed params, for a simpler conf file
		var selectapi = document.getElementById("ttsapi");
		var ttsapi = selectapi.options[selectapi.selectedIndex].value;	
	
		switch(ttsapi){
			case "voxygen":
			case "microsoft":
			case "cereproc":
			case "ispeech":
			case "watson":
			case "polly":
				///cleangenapi();
				//alert("nothing to do with "+ttsapi);
				break;
			case 'voximal':
			case 'pico':
				///cleanextapi();
				///cleangenapi();
				//alert("(2)nothing to do with "+ttsapi);
				break;
			default:
				var uri    = document.getElementById("uri");
				var wrktts = document.getElementById("workingTTS");
				var format = document.getElementById("format_wav16");
				var method = document.getElementById("method_post");
				var ssml   = document.getElementById("ssmlno");
				
				//set default woring HTTP TTS
				uri.value      = wrktts.value;
				format.checked = true;
				method.checked = true;
				ssml.checked   = true;
				
				///cleanextapi();
				break;
		}
		hiddenotused();
		
		var selasrapi = document.getElementById("asrapi");
		var asrapi    = selasrapi.options[selasrapi.selectedIndex].value;	
		//alert("tts=".ttsapi."/asr=".asrapi);
		/*if ((asrapi.search("google") != -1) || (ttsapi == "google")) 
			actdeact_ggle_credkey(true);
		else
			actdeact_ggle_credkey(false);
			*/
		
	};
	
	//Just hide or show accordinf to ttsapi value
	function hiddenotused(){
		var selectapi = document.getElementById("ttsapi");
		var ttsapi = selectapi.options[selectapi.selectedIndex].value;	
		
		switch(ttsapi){
			case "asterisk":
                                document.getElementById("eltcont_key").style.display = 'none';
                                document.getElementById("eltcont_user").style.display = 'none';
                                document.getElementById("eltcont_password").style.display = 'none';
                                document.getElementById("eltcont_voice").style.display = 'none';
                                document.getElementById("eltcont_id").style.display = 'none';
                                document.getElementById("eltcont_method").style.display = 'none';
                                document.getElementById("eltcont_ssml").style.display = 'none';
                                document.getElementById("eltcont_speed").style.display = 'none';
				break;
			case "voxygen":
			case "microsoft":
			case "ispeech":
				document.getElementById("eltcont_key").style.display = '';
				document.getElementById("eltcont_user").style.display = 'none';
				document.getElementById("eltcont_password").style.display = 'none';
				document.getElementById("eltcont_voice").style.display = '';
				document.getElementById("eltcont_id").style.display = 'none';
				document.getElementById("eltcont_method").style.display = 'none';
				document.getElementById("eltcont_ssml").style.display = 'none';
				document.getElementById("eltcont_speed").style.display = 'none';
				break;
			case "cereproc":
				document.getElementById("eltcont_key").style.display = 'none';
				document.getElementById("eltcont_user").style.display = '';
				document.getElementById("eltcont_password").style.display = '';
				document.getElementById("eltcont_voice").style.display = '';
				document.getElementById("eltcont_id").style.display = 'none';
				document.getElementById("eltcont_method").style.display = 'none';
				document.getElementById("eltcont_ssml").style.display = 'none';
				document.getElementById("eltcont_speed").style.display = '';
				break;
			case "watson":
				document.getElementById("eltcont_key").style.display = 'none';
				document.getElementById("eltcont_user").style.display = '';
				document.getElementById("eltcont_password").style.display = '';
				document.getElementById("eltcont_voice").style.display = '';
                document.getElementById("eltcont_id").style.display = 'none';
				document.getElementById("eltcont_method").style.display = 'none';
				document.getElementById("eltcont_ssml").style.display = 'none';
				document.getElementById("eltcont_speed").style.display = 'none';
				break;
			case "pico":
				document.getElementById("eltcont_ikey").style.display = 'none';
				document.getElementById("eltcont_user").style.display = 'none';
				document.getElementById("eltcont_password").style.display = 'none';
				document.getElementById("eltcont_voice").style.display = 'none';
				document.getElementById("eltcont_id").style.display = 'none';
				document.getElementById("eltcont_method").style.display = 'none';
				document.getElementById("eltcont_ssml").style.display = 'none';
				document.getElementById("eltcont_speed").style.display = 'none';
				break;
			case "voximal":
				document.getElementById("eltcont_key").style.display = 'none';
				$document.getElementById("eltcont_user").style.display = 'none';
				document.getElementById("eltcont_password").style.display = 'none';
				document.getElementById("eltcont_voice").style.display = 'none';
				document.getElementById("eltcont_id").style.display = 'none';
				document.getElementById("eltcont_method").style.display = 'none';
				document.getElementById("eltcont_ssml").style.display = 'none';
				document.getElementById("eltcont_speed").style.display = '';
				break;
			case "polly":
				document.getElementById("eltcont_key").style.display = '';
				document.getElementById("eltcont_user").style.display = 'none';
				document.getElementById("eltcont_password").style.display = '';
				document.getElementById("eltcont_voice").style.display = '';
				document.getElementById("eltcont_id").style.display = 'none';
				document.getElementById("eltcont_method").style.display = 'none';
				document.getElementById("eltcont_ssml").style.display = '';
				document.getElementById("eltcont_speed").style.display = 'none';
				break;
			case "google":
				document.getElementById("eltcont_key").style.display = '';
				document.getElementById("eltcont_user").style.display = 'none';
				document.getElementById("eltcont_password").style.display = 'none';
				document.getElementById("eltcont_voice").style.display = '';
				document.getElementById("eltcont_id").style.display = 'none';
				document.getElementById("eltcont_method").style.display = 'none';
				document.getElementById("eltcont_ssml").style.display = 'none';
				document.getElementById("eltcont_speed").style.display = 'none';
				break;
			case "yandex":
				document.getElementById("eltcont_key").style.display = '';
				document.getElementById("eltcont_user").style.display = 'none';
				document.getElementById("eltcont_password").style.display = 'none';
				document.getElementById("eltcont_voice").style.display = '';
				document.getElementById("eltcont_id").style.display = 'none';
				document.getElementById("eltcont_method").style.display = 'none';
				document.getElementById("eltcont_ssml").style.display = 'none';
				document.getElementById("eltcont_speed").style.display = 'none';
				break;
      default:
				//http or mrcp
				document.getElementById("eltcont_key").style.display = '';
				document.getElementById("eltcont_user").style.display = '';
				document.getElementById("eltcont_password").style.display = '';
				document.getElementById("eltcont_voice").style.display = '';
				document.getElementById("eltcont_id").style.display = '';
				document.getElementById("eltcont_method").style.display = '';
				document.getElementById("eltcont_ssml").style.display = '';
				document.getElementById("eltcont_speed").style.display = 'none';
		}
	}

	function ccache() {
		window.location += "&ccache=true";
	}
	
	function save() {

		document.getElementById("errMaxage").innerHTML = "";

		var form = document.getElementById("settings");
		var maxage = form.elements["maxage"].value;

		var sub_maxage = 0;

		if (isNaN(maxage)) {
			document.getElementById("errMaxage").innerHTML = "  The value must be a number.";
		} else {
			if (!isInt(maxage)) {
				document.getElementById("errMaxage").innerHTML = "  The value must be an integer.";
			} else {
				if (maxage < -1) {
					document.getElementById("errMaxage").innerHTML = "  The value is not in the correct range [-1,0...]";
				} else {
					sub_maxage = 1;
				}
			}
		}

		if (sub_maxage == 1) {
			form.submit();
		}

	}

	function isInt(n) {
		return n % 1 === 0;
	}
</script>
