<?php
/* 
 * File    : voximal-def.inc
 * Purpose : Constante definition for Voximal Freepbx module
 */


// Configuration files
if (!defined("FILE_VOXIMAL_CONF")) 	{define("FILE_VOXIMAL_CONF",	"/etc/asterisk/voximal.conf");}
if (!defined("FILE_IAXGEN_CONF")) 	{define("FILE_IAXGEN_CONF",		"/etc/asterisk/iax_general_custom.conf");}
if (!defined("FILE_IAXCUST_CONF")) 	{define("FILE_IAXCUST_CONF",	"/etc/asterisk/iax_custom.conf");}
if (!defined("FILE_TSTCALL_CONF")) 	{define("FILE_TSTCALL_CONF",	"/var/opt/voximal/testcall.conf");}

if (!defined("PATH_LOCAL_TTS")) 	{define("PATH_LOCAL_TTS",		"/var/www/html/tts/");}
if (!defined("PATH_LOCAL_ASR")) 	{define("PATH_LOCAL_ASR",		"/var/www/html/asr/");}
 
 
// VXML Validator exe definition
if (!defined("VXML_VALIDATOR")) {define("VXML_VALIDATOR",	"/usr/sbin/voximalv");}

// Google credential key file
if (!defined("FILENAME_CREDENTIALKEY")) {define("FILENAME_CREDENTIALKEY", "/usr/share/voximal/credentials-key.json");}

/*
 * Path definition
 */
if (!defined("WEBDIR")) 			{define("WEBDIR",      "/var/www/html/vxml/");}
if (!defined("AUDIODIR")) 			{define("AUDIODIR",	   "/var/spool/asterisk/");}
if (!defined("VOXIBOT_CFG")) 		{define("VOXIBOT_CFG", "/var/www/html/voxibot/configs");}
if (!defined("VOXIBOT_VXML")) 		{define("VOXIBOT_VXML","/var/www/html/voxibot/vxml/voicexml");}
if (!defined("UNIMRCP")) 	    	{define("UNIMRCP","/usr/local/unimrcp/conf");}
if (!defined("TEMPLATE")) 	    	{define("TEMPLATE","/var/www/html/admin/modules/voxistats/lib/api/tpl");}
if (!defined("ASTERISK")) 	    	{define("ASTERISK","/etc/asterisk");}

if (!defined("PATH_VALUE_VXML")) 		{define("PATH_VXML",			"vxml");}
if (!defined("PATH_VALUE_AUDIO")) 		{define("PATH_AUDIO",			"audio");}
if (!defined("PATH_VALUE_VOXICFG")) 	{define("PATH_VALUE_VOXICFG",	"voxibot-cfg");}
if (!defined("PATH_VALUE_VOXIVXML")) 	{define("PATH_VALUE_VOXIVXML",	"voxibot-vxml");}
if (!defined("PATH_VALUE_UNIMRCP")) 	{define("PATH_VALUE_UNIMRCP",	"unimrcp");}
if (!defined("PATH_VALUE_TEMPLATE")) 	{define("PATH_VALUE_TEMPLATE",	"tpl");}
if (!defined("PATH_VALUE_ASTERISK")) 	{define("PATH_VALUE_ASTERISK",	"asterisk");}


/*
 * Voximal filemanager path list
 */
class Constants {
    public static $vFilemanager_pathlist = array(	"vxml"			=> array("value" => PATH_VXML,			"path" => WEBDIR,		"display" => "Application files folder"),
													"audio"			=> array("value" => PATH_AUDIO,			"path" => AUDIODIR,		"display" => "Audio files folder"),
												  "voxibot-cfg"	=> array("value" => PATH_VALUE_VOXICFG,	"path" => VOXIBOT_CFG,	"display" => "Voxibot configuration files folder"),
													"voxibot-vxml"	=> array("value" => PATH_VALUE_VOXIVXML,"path" => VOXIBOT_VXML,	"display" => "Voxibot application files folder"),
													"unimrcp"	=> array("value" => PATH_VALUE_UNIMRCP,"path" => UNIMRCP,	"display" => "UniMRCP configuration files folder"),
													"template"	=> array("value" => PATH_VALUE_TEMPLATE,"path" => TEMPLATE,	"display" => "Template configuration files folder"),
													"asterisk"	=> array("value" => PATH_VALUE_ASTERISK,"path" => ASTERISK,	"display" => "Asterisk configuration files folder")
												);
											   
	public static function getFMpathList() {
		return self::$vFilemanager_pathlist;
	}
}

							   
?>